unit gimage;
{Pointage des taches sur l'image d'un diagramme de Laue, obtenue par scanner}
{Le fichier est un fichier bitmap}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, oemath, clipbrd, sauve;

type
  Tfgimage = class(TForm)
    Image1: TImage;
    Button2: TButton;
    OpenDialog1: TOpenDialog;
    Button3: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    ListBox1: TListBox;
    procedure sauvegarde(Sender: TObject);
    procedure pointe(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure initialise(Sender: TObject);
    procedure quitter(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fgimage: Tfgimage;

implementation

{$R *.DFM}
var
  xp_or,yp_or        : array[1..4] of integer;
  
procedure croix(x,y : integer);{
-------------------------------}
begin
  fgimage.image1.canvas.pen.color:=clred;
  fgimage.image1.canvas.moveto(x-4,y-4);
  fgimage.image1.canvas.lineto(x+4,y+4);
  fgimage.image1.canvas.moveto(x+4,y-4);
  fgimage.image1.canvas.lineto(x-4,y+4);
end;

procedure Tfgimage.sauvegarde(Sender: TObject);{
-------------------------------------------}
begin
   if(npoint > 0) then begin
     panel1.visible:=false;
     close;
     fsauve.visible:=true;
   end;
end;

procedure Tfgimage.pointe(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);{
  -----------------------------------}
var
  s,s1               : string;
begin
  croix(x,y);
  if (angle = 0) then begin
    npoint:=npoint+1;
    if(npoint = 1)then begin
      if(image1.top > 20) then begin
        panel1.top:=image1.top;
      end else begin
        panel1.top:=20;
      end;
      panel1.left:=image1.left;
      panel1.color:=clblue;
      panel1.width:=image1.width;
      panel1.caption:=
      'Origin measured. Now click on the reflections to be measured';
      x_origine:=x;
      y_origine:=y;
      exit;
    end;
  end;
  if (round(abs(angle)) = 180) and (npoint < 4) then begin
    npoint:=npoint+1;
    if (npoint < 5) then begin
      xp_or[npoint]:=x;
      yp_or[npoint]:=y;
      str(x:5,s);
      str(y:5,s1);
      s:=s+s1;
      panel1.caption:=s;
      if (npoint = 4) then begin
        x_origine:=(xp_or[1]+xp_or[2]) div 2;
        y_origine:=(yp_or[3]+yp_or[4]) div 2;
        if(image1.top > 20) then begin
           panel1.top:=image1.top;
        end else begin
          panel1.top:=20;
        end;
        panel1.left:=image1.left;
        panel1.color:=clblue;
        panel1.width:=image1.width;
        panel1.caption:=
        'Origin measured. Now click on the reflections to be measured';
      end;
    end;
    exit;
  end;
  nobs:=nobs+1;
  xobs[nobs]:=(x-x_origine)/nb_pixel_cm;
  yobs[nobs]:=(y_origine-y)/nb_pixel_cm;

  str(nobs:2,s1);
  image1.canvas.textout(x+7,y-7,s1);

   s:=s1+' x= ';
   str(xobs[nobs]:6:2,s1);
   s:=s+s1+' y=';
   str(yobs[nobs]:6:2,s1);
   s:=s+s1;
   yw:=yw+15;
   {canvas.textout(xw,yw,s);}
   listbox1.items.add(s);
   {npoint:=npoint+1;}
end;

procedure Tfgimage.initialise(Sender: TObject);{
-----------------------------------------------}
var
  i                  : integer;
begin

  xw:=5;
  yw:=5;
  npoint:=0;

  listbox1.clear;

  {Effacement de l'ecran }
  canvas.FloodFill(0,0,clblack,fsborder);

  {Chargement de l'image et mise dans le presse-papier}
  image1.Picture.LoadFromFile(nom_fichier_image);
  ClipBoard.assign(image1.Picture);
  image1.cursor:=CrCross;

  caption:=nom_fichier_image;

  {Fontes Cannevas fiche}
  canvas.font.name:='system';
  canvas.font.color:=clred;
  canvas.font.size:=8;

  {Fontes image1}
  image1.canvas.font.name:='courier';
  image1.canvas.font.color:=clblue;
  image1.canvas.brush.color:=clsilver;
  image1.canvas.font.size:=6;
  image1.canvas.pen.color:=clwhite;

  {Ajustement de la taille de image1}
  fgimage.image1.width:=round(largeur*nb_pixel_cm);
  fgimage.image1.height:=round(hauteur*nb_pixel_cm);
  fgimage.image1.left:=(fgimage.width-fgimage.image1.width) div 2;
  fgimage.image1.top:=(fgimage.height-fgimage.image1.height) div 2;

  if(image1.top > 20) then begin
     panel1.top:=image1.top;
  end else begin
     panel1.top:=20;
  end;
  panel1.left:=image1.left;
  panel1.width:=image1.width;
  panel1.color:=clred;
  if (angle = 0) then panel1.caption:='Point at the center of the diagram';
  if (round(abs(angle)) = 180)then begin
    panel1.caption:=
    'Refexion Geometry. Click 4 points (Left-Right-Up-Down) around the origin';
  end;

end;

procedure Tfgimage.quitter(Sender: TObject);{
--------------------------------------------}
begin
  cursor:=crDefault;
  close;
end;

end.
