procedure croix(x,y : integer);{
-------------------------------}
begin
  with flimage1.image1.canvas do begin
    moveto(x-4,y-4);
    lineto(x+4,y+4);
    moveto(x+4,y-4);
    lineto(x-4,y+4);
    moveto(x-4,y);
    lineto(x+4,y);
    moveto(x,y-4);
    lineto(x,y+4);
  end;
end;

procedure ecrit_coord_listbox;{
------------------------------}
var
  i        : integer;
  s,s1,s2  : string;
begin
    flimage1.listbox1.clear;
    flimage1.image1.picture.assign(clipboard);
    if(nobs > 0)then begin
      for i:=1 to nobs do begin
        str(i:2,s);
        flimage1.image1.canvas.textout(px_obs[i]+4,py_obs[i],s);
        croix(px_obs[i],py_obs[i]);
        str(xobs[i]:5:2,s1);
        str(yobs[i]:5:2,s2);
        s:=s+' '+s1+' '+s2;
        flimage1.listbox1.items.Add(s);
      end;
    end;
end;

{Rappel du presse-papier pour effacer}
procedure gomme;{
----------------}
begin
     flimage1.image1.picture.Assign(ClipBoard);
end;

{Remise  zro des flag}
procedure reset_flag;{
---------------------}
begin
  flimage1.caption:='OrientExpress';
  flag_origine:=false;
  flag_mesure:=false;
  flag_scale:=false;
  flag_cercle:=false;
  flag_point:=false;
end;

{Trac d'un cercle sur 100 points}
procedure trace_cercle(x,y: integer);{
-------------------------------------}
var
   i   : integer;
begin
    x_dernier:=x;
    y_dernier:=y;
    flimage1.image1.canvas.moveto(x+round(coordx[1]*rayon),
                                y+round(coordy[1]*rayon));
    for i:=2 to 100 do
     flimage1.image1.canvas.lineto(x+round(coordx[i]*rayon),
                                 y+round(coordy[i]*rayon));
    flimage1.refresh;
end;

{Ecriture sur l'image de l'origine et de l'chelle}
procedure display_panel4;{
-------------------------}
var
  s,s1  : string;
  nomf  : TextFile;
begin
  if(x_origine <> 0) or (y_origine <> 0)then begin
    flimage1.label1.enabled:=true;
    str(x_origine:4,s1);
    s:='Origin at '+s1;
    str(y_origine:4,s1);
    s:=s+' '+s1;
  end else begin
    s:='Unknown origin';
  end;
  flimage1.label1.caption:=s;

  if (nb_pixel_cm <> 0)then begin
    str(nb_pixel_cm:7:2,s1);
    s:='Nb pix./Cm:'+s1;
  end else begin
    s:='Unknown scale';
  end;
  flimage1.label3.caption:=s;
  if (nb_pixel_cm > 0) and (x_origine > 0) and (y_origine > 0)then begin
    AssignFile(nomf,'imageconst.txt');
    rewrite(nomf);
    writeln(nomf,nb_pixel_cm:7:2);
    writeln(nomf,x_origine:5,y_origine:5);
    closeFile(nomf);
    flimage1.measurecoord1.enabled:=true;
    flimage1.origin1.enabled:=true;
  end;

end;

{Effacement avec criture des coordonnes dans ListBox1}
procedure efface;{
-----------------}
var
   i,xw2,yw2   : integer;
   s,s1,s2     : string;
begin

  yw2:=20;
  xw2:=700;
  flimage1.image1.picture.Assign(ClipBoard);
  flimage1.listbox1.items.clear;
  if flag_mesure then begin
    flag:=1;
    ecrit_coord_listbox;
    (*if(nobs > 0)then begin
      for i:=1 to nobs do begin
        str(i:2,s);
        flimage1.image1.canvas.textout(px_obs[i]+4,py_obs[i],s);
        croix(px_obs[i],py_obs[i]);
        yw2:=yw2+15;
        str(xobs[i]:5:2,s1);
        str(yobs[i]:5:2,s2);
        s:=s+' '+s1+' '+s2;
        flimage1.listbox1.items.Add(s);
      end;
    end;*)
  end;
  if flag_scale then begin
    flag:=1;
    for i:= 1 to  nb_point_scale do begin
      croix(x_scale[i],y_scale[i]);
      yw2:=yw2+15;
      str(x_scale[i]:3,s1);
      str(y_scale[i]:3,s2);
      s:=s+' '+s1+' '+s2;
      flimage1.listbox1.items.add(s);
    end;
  end;
  if (x_origine <> 0) and (y_origine <> 0) then croix(x_origine,y_origine);
 end;

function lit(rang,nb_bytes: integer):integer;{
----------------------------------------------}
var
  contenu: integer;
begin
  contenu:=ord(tampon[rang])+256*ord(tampon[rang+1]);
  if(nb_bytes = 4)then contenu:=contenu+
  65536*ord(tampon[rang+2])+16777216*ord(tampon[rang+3]);
  lit:=contenu ;
end;

(*{Lecture du header du fichier nom_fichier_image}
procedure lit_header;{
---------------------}
var
  nomf    : File;
  result  : integer;

begin
  AssignFile(nomf,nom_fichier_image);
  reset(nomf);
  blockread(nomf,tampon,1,result);
  largeur_image:=lit(19,4);
  hauteur_image:=lit(23,4);
  closefile(nomf);
 end; *)

{Option File. Lecture du nom de fichier}
procedure Tflimage1.lecture_nom_fichier(Sender: TObject);{
--------------------------------------------}
var
  nomf      : textfile;
begin
   OpenDialog1.filterIndex:=1;
   if OpenDialog1.execute then begin
     nom_fichier_image:=OpenDialog1.FileName;
     {Effacement de l'ecran}
     canvas.FloodFill(0,0,clblack,fsborder);
     n_origine:=0;
     x_origine:=0;
     y_origine:=0;
     nb_pixel_cm:=0;
     xw:=2;
     yw:=2;
     display_panel4;
     scale1.enabled:=true;
     origin1.enabled:=true;
     measurecoord1.enabled:=false;
     savecoord1.enabled:=false;
     panel1.visible:=true;
     panel1.caption:='';
     panel4.visible:=true;
     image1.Picture.LoadFromFile(nom_fichier_image);
     ClipBoard.assign(image1.Picture);
     flag_image:=true;
     label1.visible:=true;
     label3.visible:=true;
     if fileExists('imageconst.txt') then begin
       AssignFile(nomf,'imageconst.txt');
       reset(nomf);
       readln(nomf,nb_pixel_cm);
       readln(nomf,x_origine,y_origine);
       closeFile(nomf);
       display_panel4;
     end;
  end;

end;
