unit Reorient;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, printers, SysUtils, math, Grids;

type
  Tfreorient = class(TForm)
    Panel1: TPanel;
    Label2: TLabel;
    Label4: TLabel;
    button1: TBitBtn;
    Image1: TImage;
    Bevel1: TBevel;
    Panel5: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    RadioGroup2: TRadioGroup;
    BitBtn1: TBitBtn;
    Label3: TLabel;
    Label5: TLabel;
    Panel3: TPanel;
    Panel4: TPanel;
    BitBtn2: TBitBtn;
    Label6: TLabel;
    Edit12: TEdit;
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    StringGrid3: TStringGrid;
    StringGrid4: TStringGrid;
    Panel2: TPanel;
    BitBtn3: TBitBtn;
    Panel11: TPanel;
    Label10: TLabel;
    Label11: TLabel;
    RadioGroup1: TRadioGroup;
    procedure sortie_reorient(Sender: TObject);
    procedure affiche_angles(Sender: TObject);
    procedure initialise_activate(Sender: TObject);
    procedure imprime_ang(Sender: TObject);
    procedure peint_grille1(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure peint_grille2(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure peint_grille3(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure peint_grille4(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure select_grille1(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure selct_grille2(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure select_grille3(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure select_grille4(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure onclic1(Sender: TObject);
    procedure init_create(Sender: TObject);
    procedure aide(Sender: TObject);
    procedure efface_grid(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Type
  tab_matrice = array[1..3,1..3,1..8] of real;
  typ_real6   = array[1..6] of real;

var
  freorient                           : Tfreorient;
  reseau                              : integer;

implementation

{$R *.DFM}
uses
   Dessin, oemath;
var
  numero_grille,arow,acol                        : integer;

(*
procedure hklRtoH(var hr,kr,lr,hh,kh,lh: integer);
//------------------------------------------------
begin
  hh:=hr-kr;
  kh:=kr-lr;
  lh:=hr+kr+lr;
  premier2(hh,kh,lh);
end;

procedure xyzRtoH(var xr,yr,zr,xh,yh,zh: real);
//---------------------------------------------
begin
  xh:=(2*xr-yr-zr)/3;
  yh:=(xr+yr-2*zr)/3;
  zh:=(xr+yr+zr)/3;
end;
*)

procedure hklHtoR(var xh,yh,zh: real);
//------------------------------------
//entres: coordonnes h,k,l hexagonales (pas forcment entires).
//Sorties: coordonnes rhombo.
var
  x,y,z           : real;
begin
  x:=(2*xh+yh+zh)/3;
  y:=(-xh+yh+zh)/3;
  z:=(-xh-2*yh+zh)/3;
  xh:=x;
  yh:=y;
  zh:=z;
end;

Procedure xyzHtoR(var xx,yy,zz : real);
//------------------------------------
//entres: coordonnes x,y,z hexagonales. Sorties: coordonnes rhombo.
var
  x,y,z        : real;
begin
  x:=xx+zz;
  y:=-xx+yy+zz;
  z:=-yy+zz;
  xx:=x;
  yy:=y;
  zz:=z;
end;

//angle de 2 vecteurs en coordonnees ortho.
function ang1(x,y:vecteur3):real;{
---------------------------------}
var den                    :real;
begin
  den:=sqrt((x[1]*x[1]+x[2]*x[2]+x[3]*x[3])*(Y[1]*Y[1]+Y[2]*Y[2]+Y[3]*Y[3]));
  ang1:=arcos(x[1]*y[1]+x[2]*y[2]+x[3]*y[3])/den;
end;

{Matrices de rotation AX autour de OX, et AY autour de OY, AZ autour de OZ}
Procedure setrot(phix,phiy,phiz:real; var ax,ay,az:matrice3);{
-------------------------------------------------------------}
var
  i,j        : integer;

begin
   for i:=1 to 3 do begin
     for j:=1 to 3 do begin
        ax[i,j]:=0;
        ay[i,j]:=0;
        az[i,j]:=0;
     end;
   end;
   phix:=phix/57.2957;phiy:=phiy/57.2957;phiz:=phiz/57.2957;
   ax[1,1]:=1;
   ax[2,2]:=cos(phix);
   ax[3,3]:=ax[2,2];
   ax[2,3]:=sin(phix);
   ax[3,2]:=-ax[2,3];

   ay[1,1]:=cos(phiy);
   ay[2,2]:=1;
   ay[3,3]:=ay[1,1];
   ay[3,1]:=sin(phiy);
   ay[1,3]:=-ay[3,1];

   az[1,1]:=cos(phiz);
   az[2,2]:=az[1,1];
   az[3,3]:=1;
   az[1,2]:=sin(phiz);
   az[2,1]:=-az[1,2];

end;

{Calcul de la matrice d'orientation aprs rotation autour de 2 des 3 axes
slectionns par n (rorientation)}
procedure atrot(phix,phiy,phiz: real; var rr:tab_matrice; n:integer);{
---------------------------------------------------------------------}
var   i,j              :integer;
      r,ax,ay,az       :matrice3;

begin
  setrot(phix,phiy,phiz,ax,ay,az);
  case n of
    1: mat_mult(ax,az,r);
    2: mat_mult(ay,az,r);
    3: mat_mult(ax,ay,r);
    4: mat_mult(az,ay,r);
    5: mat_mult(az,ay,r);
    6: mat_mult(ax,ay,r);
    7: mat_mult(ay,ax,r);
    8: mat_mult(az,ax,r);
  end ;
  trspo(r);
  for i:=1 to 3 do begin
    for j:=1 to 3 do begin
      rr[i,j,n]:=r[i,j]
    end;
  end;
end;

procedure Tfreorient.sortie_reorient(Sender: TObject);{
------------------------------------------------------}
begin
  close;
end;

procedure affiche_ligne(a :typ_real6;numero:integer);{
------------------------------------------------------}
var
  s1  : string;
  i   : integer;
begin
  with freorient.stringgrid1 do begin
    for i:=1 to 3 do begin
      str(a[i]:7:2,s1);
      s1:=trim(s1);
      cells[i,numero]:=s1;
    end;
  end;
  with freorient.stringgrid2 do begin
    for i:=4 to 6 do begin
      str(a[i]:7:2,s1);
      cells[i-3,numero]:=s1;
    end;
  end;
end;

procedure affiche_ligne2(a :typ_real6;numero:integer);{
------------------------------------------------------}
var
  s1  : string;
  i   : integer;
begin
  with freorient.stringgrid3 do begin
    for i:=1 to 3 do begin
      str(a[i]:7:2,s1);
      cells[i,numero]:=s1;
    end;
  end;
  with freorient.stringgrid4 do begin
    for i:=4 to 6 do begin
      str(a[i]:7:2,s1);
      cells[i-3,numero]:=s1;
    end;
  end;
 end;

{Affichage des angles de rotation}
procedure Tfreorient.affiche_angles(Sender: TObject);{
-----------------------------------------------------}
const
  axx : vecteur3=(1,0,0);
  axy : vecteur3=(0,1,0);
  axz : vecteur3=(0,0,1);
  rad : real=57.29578;
var
  s,s1,s2,s3                                  : string;
  a1,a2,a3                                    : real;
  xd                                          : vecteur3;
  x,y,z,sqx,sqy,sqz                           : real;
  phix1,phix2,phiy1,phiy2,phiz1,phiz2         : real;
  espace,ier,no_exept                         : integer;
  ang                                         : typ_real6;
  nomf: TextFile;
begin
  (*assignFile(nomf,'espion');
  rewrite(nomf);*)
  if (edit1.text = '')then edit1.text:='0';
  if (edit2.text = '')then edit2.text:='0';
  if (edit3.text = '')then edit3.text:='0';
  if (edit1.text = '0') and (edit2.text = '0') and (edit3.text = '0')then exit;
  if(radiogroup2.itemindex = -1)then begin
    erreur('Select the space');
    exit;
  end;
  panel1.visible:=true;
  panel2.visible:=true;
  panel4.visible:=true;
  panel3.visible:=true;
  reseau:=radiogroup2.itemIndex;
  edit12.text:=sample_ref;

//Rcupration des directions
  edit1.setFocus;
  s:=edit1.text;
  if (s  = '') then s:='0';
  add_zero(s);
  val(s,x,ier);
  if (ier <> 0) then begin
    edit1.setFocus;
    radiogroup2.itemIndex:=0;
    erreur('Type error (X)!');
    exit;
  end;
  s:=edit2.text;
  if (s  = '') then s:='0';
  add_zero(s);
  val(s,y,ier);
  if (ier <> 0) then begin
    edit2.setFocus;
    radiogroup2.itemIndex:=0;
    erreur('Type error (Y)!');
    exit;
  end;
  s:=edit3.text;
  if (s = '') then s:='0';
  add_zero(s);
  val(s,z,ier);
  if(ier <> 0)then begin
    edit3.setFocus;
    radiogroup2.itemIndex:=0;
    erreur('Tpe error (Z)!');
    exit;
  end;
  espace:=radiogroup2.ItemIndex;

//4/11/2002: Systme rhombodrique, Affichage en hexa
  if panel11.visible and (radiogroup1.itemindex = 0) then begin
    if (radiogroup2.itemindex = 0)then xyzHtoR(x,y,z);
    if (radiogroup2.itemindex = 1)then hklHtoR(x,y,z);
  end;

//Espace rel ou rciproque?
  if (espace = 0) then trfo2(x,y,z,r10);
   {Angles de la direction avec les axes du repre}
   trfo2(x,y,z,r31);
   norm(x,y,z);
   xd[1]:=x;
   xd[2]:=y;
   xd[3]:=z;
   a1:=ang1(xd,axx);
   a2:=ang1(xd,axy);
   a3:=ang1(xd,axz);
   {Exeptions}
   no_exept:=0;
   if(abs(sin(a1)) < 0.0001) then no_exept:=1;
   if(abs(sin(a3)) < 0.0001) then no_exept:=2;
   a1:=rad*a1;
   a2:=rad*a2;
   a3:=rad*a3;
   {Angles avec les axes}
   s1:=edit1.text;
   s1:=trim(s1);
   s2:=edit2.text;
   s2:=trim(s2);
   s3:=edit3.text;
   s3:=trim(s3);
   if (radiogroup2.itemindex = 0) then s3:=s3+ '(D)';
   if (radiogroup2.itemindex = 1) then s3:=s3+ '(R)';
   s:='Angles of the direction '+s1+' '+s2+' '+s3+' with X,Y,Z room axis: ';

   str(a1:7:2,s1);
   str(a2:7:2,s2);
   str(a3:7:2,s3);
   s:=s+s1+s2+s3;
   panel2.caption:=s;

   sqx:=sqrt(1-x*x);
   sqy:=sqrt(1-y*y);
   sqz:=sqrt(1-z*z);

   {//OX}
//Cas NO. 1 Rotation ZX' (support 1 equerre) sur OX
   (*writeln(nomf,'no_exept:',no_exept);
   writeln(nomf,'x,y,z',x:10:5,y:10:5,z:10:5);*)
   phiy1:=0;phiy2:=0;
   phiz1:=arctan2(-sqx,x);
   phix1:=arctan2(-z,y);
   //writeln(nomf,'phix1,phiz1,avant',phix1:6:3,phiz1:6:3);
   if(no_exept = 1)then begin
     phiz1:=0;
     phix1:=0;
   end;
   if(no_exept = 2) then begin
     phiz1:=pi/2;
     phix1:=pi/2;
   end;
   phix2:=pi+phix1;
   phiz2:=-phiz1;
   phiz1:=phiz1*rad;
   phix1:=phix1*rad;
   phiz2:=phiz2*rad;
   phix2:=phix2*rad;
   if (phix2 > 180) then phix2:=phix2-360.;
   ang[1]:=phix1;ang[2]:=phiy1;ang[3]:=phiz1;
   ang[4]:=phix2;ang[5]:=phiy2;ang[6]:=phiz2;
   affiche_ligne(ang,1);
   //writeln(nomf,'phix1,phiz1,apres',phix1:6:3,phiz1:6:3);
   //closefile(nomf);
//Cas no. 2 : rotation zy'(support 1 querre)
   phix1:=0;phix2:=0;
   phiz1:=arctan2(-y,sqy);
   phiy1:=arctan2(z,x);
   if(no_exept = 1)then begin
     phiy1:=0;
     phiz1:=0;
   end;
   if(no_exept = 2) then begin
     phiz1:=0;
     phiy1:=pi/2;
   end;
   phiy2:=pi+phiy1;
   phiz2:=-phiz1;
   phiz1:=phiz1*rad;
   phiy1:=phiy1*rad;
   phiz2:=phiz2*rad;
   phiy2:=phiy2*rad;
   if (phiy2 > 180) then phiy2:=phiy2-360;
   ang[1]:=phix1;ang[2]:=phiy1;ang[3]:=phiz1;
   ang[4]:=phix2;ang[5]:=phiy2;ang[6]:=phiz2;
   affiche_ligne(ang,2);

   {Cas Nb. 3 : rotation yx'(tte goniomtrique)}
   phiz1:=0;
   phiz2:=0;
   phiy1:=arctan2(sqx,x);
   phix1:=arctan2(y,z);
   if (no_exept = 1) then begin
     phix1:=0;
     phiy1:=0;
   end;
   if (no_exept = 2) then begin
     phiy1:=pi/2;
     phix1:=0;
   end;
   phix2:=phix1+pi;
   phiy2:=-phiy1;
   phiy1:=phiy1*rad;
   phix1:=phix1*rad;
   phiy2:=phiy2*rad;
   phix2:=phix2*rad;
   if (phix2 > 180) then phix2:=phix2-360.;
   ang[1]:=phix1;ang[2]:=phiy1;ang[3]:=phiz1;
   ang[4]:=phix2;ang[5]:=phiy2;ang[6]:=phiz2;
   affiche_ligne(ang,3);
   {Cas Nb.4 : rotation yz'}
   phix1:=0;
   phix2:=0;
   phiy1:=arctan2(z,sqz);
   phiz1:=arctan2(-y,x);
   if (no_exept = 1)then begin
     phiy1:=0;
     phiz1:=0;
  end;
   if (no_exept =2) then begin
     phiy1:=pi/2;
     phiz1:=0;
   end;
   phiz2:=pi+phiz1;
   phiy2:=-phiy1;
   phiz1:=phiz1*rad;
   phiy1:=phiy1*rad;
   phiz2:=phiz2*rad;
   phiy2:=phiy2*rad;
   if(phiz2 > 180) then phiz2:=phiz2-360.;
   ang[1]:=phix1;ang[2]:=phiy1;ang[3]:=phiz1;
   ang[4]:=phix2;ang[5]:=phiy2;ang[6]:=phiz2;
   affiche_ligne(ang,4);

   {//:OZ}
//Cas Nb. 5 : rotation yz' (support 2 querres)
   phix1:=0;phix2:=0;
   phiy1:=arctan2(-sqz,z);
   phiz1:=arctan2(-y,x);
   if (no_exept = 1) then begin
     phiy1:=pi/2;
     phiz1:=0;
   end;
   if (no_exept = 2)then begin
     phiy1:=0;
     phiz1:=0;
   end;
   phiz2:=pi+phiz1;
   phiy2:=-phiy1;
   phiy1:=phiy1*rad;
   phiz1:=phiz1*rad;
   phiy2:=phiy2*rad;
   phiz2:=phiz2*rad;
   if (phiz2 > 180) then phiz2:=phiz2-360.;
   ang[1]:=phix1;ang[2]:=phiy1;ang[3]:=phiz1;
   ang[4]:=phix2;ang[5]:=phiy2;ang[6]:=phiz2;
   affiche_ligne2(ang,1);
  {Cas Nb. 6 : rotation yx' (tte goniomtrique)}
   phiz1:=0;phiz2:=0;
   phiy1:=arctan2(-x,sqx);
   phix1:=arctan2(y,z);
   if (no_exept = 1)then begin
     phiy1:=pi/2;
     phix1:=0;
   end;
   if(no_exept = 2)then begin
     phiy1:=0;
     phix1:=0;
   end;
   phix2:=pi+phix1;
   phiy2:=-phiy1;
   phiy1:=phiy1*rad;
   phix1:=phix1*rad;
   phiy2:=phiy2*rad;
   phix2:=phix2*rad;
   if (phix2 > 180) then phix2:=phix2-360;
   ang[1]:=phix1;ang[2]:=phiy1;ang[3]:=phiz1;
   ang[4]:=phix2;ang[5]:=phiy2;ang[6]:=phiz2;
   affiche_ligne2(ang,2);

//cas Nb. 7 : rotation xy'}
   phiz1:=0;phiz2:=0;
   phix1:=arctan2(y,sqy);
   phiy1:=arctan2(-x,z);
   if (no_exept = 1)then begin
     phix1:=0;
     phiy1:=pi/2;
   end;
   if (no_exept = 2)then begin
     phix1:=0;
     phiy1:=0;
   end;
   phiy2:=pi+phiy1;
   phix2:=-phix1;
   phiy1:=phiy1*rad;
   phix1:=phix1*rad;
   phiy2:=phiy2*rad;
   phix2:=phix2*rad;
   if(phiy2 > 180) then phiy2:=phiy2-360;
   ang[1]:=phix1;ang[2]:=phiy1;ang[3]:=phiz1;
   ang[4]:=phix2;ang[5]:=phiy2;ang[6]:=phiz2;
   affiche_ligne2(ang,3);
//cas Nb. 8 : rotation xz'
   phiy1:=0;phiy2:=0;
   phix1:=arctan2(sqz,z);
   phiz1:=arctan2(x,y);
   if( no_exept = 1)then begin
     phix1:=pi/2;
     phiz1:=pi/2;
   end;
   if (no_exept = 2)then begin
     phix1:=0;
     phiz1:=0;
   end;
   phiz2:=pi+phiz1;
   phix2:=-phix1;
   phiz1:=phiz1*rad;
   phix1:=phix1*rad;
   phiz2:=phiz2*rad;
   phix2:=phix2*rad;
   if(phiz2 > 180) then phiz2:=phiz2-360;
   ang[1]:=phix1;ang[2]:=phiy1;ang[3]:=phiz1;
   ang[4]:=phix2;ang[5]:=phiy2;ang[6]:=phiz2;
   affiche_ligne2(ang,4);
end;

procedure Tfreorient.initialise_activate(Sender: TObject);{
----------------------------------------------------------}
var  i: integer;
begin
  panel1.visible:=false;
  if (systeme = 'RHOM') and (copy(groupe_espace,1,1)= 'R')then begin
     panel11.visible:=true;
     radiogroup1.itemindex:=1;
  end else panel11.visible:=false;
  with stringgrid1 do begin
    cells[0,0]:='Rot.';
    cells[1,0]:='PhiX';Cells[2,0]:='PhiY';Cells[3,0]:='PhiZ';
    cells[0,1]:='1: ZX''';
    cells[0,2]:='2: ZY''';
    cells[0,3]:='3: YX''';
    cells[0,4]:='4: YZ''';
  end;
  with stringgrid2 do begin
    cells[0,0]:='Rot.';
    cells[1,0]:='PhiX';Cells[2,0]:='PhiY';Cells[3,0]:='PhiZ';
    cells[0,1]:='5: ZX''';
    cells[0,2]:='6: ZY''';
    cells[0,3]:='7: YX''';
    cells[0,4]:='8: YZ''';
 end;
  with stringgrid3 do begin
    cells[0,0]:='Rot.';
    cells[1,0]:='PhiX';Cells[2,0]:='PhiY';Cells[3,0]:='PhiZ';
    cells[0,1]:='1: YZ''';
    cells[0,2]:='2: YX''';
    cells[0,3]:='3: XY''';
    cells[0,4]:='4: XZ''';
  end;
  with stringgrid4 do begin
    cells[0,0]:='Rot.';
    cells[1,0]:='PhiX';Cells[2,0]:='PhiY';Cells[3,0]:='PhiZ';
    cells[0,1]:='5: YZ''';
    cells[0,2]:='6: YX''';
    cells[0,3]:='7: XY''';
    cells[0,4]:='8: XZ''';
 end;
 //ident(r13,r13_old);
end;

procedure Tfreorient.imprime_ang(Sender: TObject);{
--------------------------------------------------}
Var
 MyFile   : System.Text;
 s,s1     : String;
begin
    screen.cursor:=crHourGlass;
    AssignPrn(MyFile);
    ReWrite(MyFile);
    printer.canvas.font.name:='Courier';
    s:=DateTimeToStr(Now);
    writeln(MyFile,s);
    writeln(MyFile,'Title: '+titre);
    sample_ref:=edit12.text;
    writeln(MyFile,'Sample reference: '+sample_ref);

    writeln(MyFile);
    if (radiogroup2.ItemIndex = 0)then
      s:='Direction '+edit1.text+','+edit2.text+','
                     +edit3.text+' of the direct space';
    if (radiogroup2.ItemIndex = 1)then
      s:='Direction '+edit1.text+edit2.text
                     +edit3.text+' of the recipr. space';

  if panel11.visible and (radiogroup1.itemindex = 0) then begin
    if (radiogroup2.itemindex = 0)then s:=s+'  (Hexagonal cell)';
  end;

    writeln(MyFile,s);
    writeln(MyFile);
    writeln(Myfile,panel2.caption);
    writeln(MyFile);
    s:='                                Rotation Angles';
    writeln(MyFile,s);
    writeln(MyFile);

    s:='                          Parallel to the beam axis (OX)';
    writeln(MyFile,s);
    writeln(MyFile);

    s:=StringGrid1.cells[3,1]; //N1 (ZX')
    s:='Rot. Nb. 1(ZX''): PhiZ='+s;
    s1:=StringGrid1.cells[1,1];
    s:=s+' PhiX''='+s1;
    s1:=StringGrid2.cells[3,1];
    s:=s+' or PhiZ='+ s1;
    s1:=StringGrid2.cells[1,1];
    s:=s+' PhiX''='+s1;
    writeln(MyFile,s);

    s:=StringGrid1.cells[3,2]; //N2 (ZY')
    s:='Rot. Nb. 2(ZY''): PhiZ='+s;
    s1:=StringGrid1.cells[2,2];
    s:=s+' PhiY''='+s1;
    s1:=StringGrid2.cells[3,2];
    s:=s+' or PhiZ='+ s1;
    s1:=StringGrid2.cells[2,2];
    s:=s+' PhiY''='+s1;
    writeln(MyFile,s);

    s:=StringGrid1.cells[2,3]; //N3(YX')
    s:='Rot. Nb. 3(YX''): PhiY='+s;
    s1:=StringGrid1.cells[1,3];
    s:=s+' PhiX''='+s1;
    s1:=StringGrid2.cells[2,3];
    s:=s+' or PhiY='+ s1;
    s1:=StringGrid2.cells[1,3];
    s:=s+' PhiX''='+s1;
    writeln(MyFile,s);

    s:=StringGrid1.cells[2,4]; //N4 (YZ')
    s:='Rot. Nb. 4(YZ''): PhiY='+s;
    s1:=StringGrid1.cells[3,4];
    s:=s+' PhiZ''='+s1;
    s1:=StringGrid2.cells[2,4];
    s:=s+' or PhiY='+ s1;
    s1:=StringGrid2.cells[3,4];
    s:=s+' PhiZ''='+s1;
    writeln(MyFile,s);

    writeln(MyFile);
    s:='                          Parallel to the camera axis (OZ)';
    writeln(MyFile,s);
    writeln(MyFile);
    s:=StringGrid3.cells[2,1]; //N4 (YZ')
    s:='Rot. Nb. 5(YZ''): PhiY='+s;
    s1:=StringGrid3.cells[3,1];
    s:=s+' PhiZ''='+s1;
    s1:=StringGrid4.cells[2,1];
    s:=s+' or PhiY='+ s1;
    s1:=StringGrid4.cells[3,1];
    s:=s+' PhiZ''='+s1;
    writeln(MyFile,s);

    s:=StringGrid3.cells[2,2]; //N5(YX')
    s:='Rot. Nb. 6(YX''): PhiY='+s;
    s1:=StringGrid3.cells[1,2];
    s:=s+' PhiX''='+s1;
    s1:=StringGrid4.cells[2,2];
    s:=s+' or PhiY='+ s1;
    s1:=StringGrid4.cells[1,2];
    s:=s+' PhiX''='+s1;
    writeln(MyFile,s);


    s:=StringGrid3.cells[1,3]; //N7 (XY')
    s:='Rot. Nb. 7(XY''): PhiX='+s;
    s1:=StringGrid3.cells[2,3];
    s:=s+' PhiY''='+s1;
    s1:=StringGrid4.cells[1,3];
    s:=s+' or PhiX='+ s1;
    s1:=StringGrid4.cells[2,3];
    s:=s+' PhiY''='+s1;
    writeln(MyFile,s);

    s:=StringGrid3.cells[1,4]; //N8 (XZ')
    s:='Rot. Nb. 8(XZ''): PhiX='+s;
    s1:=StringGrid3.cells[3,4];
    s:=s+' PhiZ''='+s1;
    s1:=StringGrid4.cells[1,4];
    s:=s+' or PhiX='+ s1;
    s1:=StringGrid4.cells[3,4];
    s:=s+' PhiZ''='+s1;
    writeln(MyFile,s);

    System.Close(Myfile);
    screen.cursor:=crDefault;

end;

procedure Tfreorient.peint_grille1(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//----------------------------------------------------------------------
var
  s   : string;
  posx: integer;
begin
  (*if (row = no_select_raie) then begin
      stringgrid1.canvas.brush.color:=$EECBFF;
      stringgrid1.canvas.fillrect(rect);
      stringgrid1.canvas.font.color:=clblack;
      stringgrid1.canvas.textout(rect.left+2,rect.top+2,stringgrid1.cells[col,row]);
  end else begin*)
    s:=stringgrid1.cells[col,row];
    posx:= ((Rect.right-rect.left-2)-stringgrid1.canvas.textWidth(s)) div 2;
    stringgrid1.canvas.textrect(rect,rect.left+posx,rect.top,s);
  //end;

end;

procedure Tfreorient.peint_grille2(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//-------------------------------------------------------------------
var
  s   : string;
  posx: integer;
begin
    s:=stringgrid2.cells[col,row];
    posx:= ((Rect.right-rect.left-2)-stringgrid2.canvas.textWidth(s)) div 2;
    stringgrid2.canvas.textrect(rect,rect.left+posx,rect.top,s);
end;

procedure Tfreorient.peint_grille3(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//-------------------------------------------------------------------
var
  s   : string;
  posx: integer;
begin
    s:=stringgrid3.cells[col,row];
    posx:= ((Rect.right-rect.left-2)-stringgrid3.canvas.textWidth(s)) div 2;
    stringgrid3.canvas.textrect(rect,rect.left+posx,rect.top,s);
end;

procedure Tfreorient.peint_grille4(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//-------------------------------------------------------------------
var
  s   : string;
  posx: integer;
begin
    s:=stringgrid4.cells[col,row];
    posx:= ((Rect.right-rect.left-2)-stringgrid4.canvas.textWidth(s)) div 2;
    stringgrid4.canvas.textrect(rect,rect.left+posx,rect.top,s);
end;

procedure Tfreorient.select_grille1(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
begin
  arow:=row;acol:=col;
  numero_grille:=1;
end;

procedure Tfreorient.selct_grille2(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
begin
  arow:=row;acol:=col;
  numero_grille:=2;
end;

procedure Tfreorient.select_grille3(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
begin
  arow:=row;acol:=col;
  numero_grille:=3;
end;

procedure Tfreorient.select_grille4(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
begin
  arow:=row;acol:=col;
  numero_grille:=4;
end;

procedure Tfreorient.onclic1(Sender: TObject);
//--------------------------------------------
var
  s1,s2,s3,s       : string;
  phix,phiy,phiz   :  real;
  ier,i,j,cas      : integer;
  ax,ay,az,r,aux   : matrice3;
begin
   //Lecture des angles  la ligne arow
   case numero_grille of
   1: begin
        with stringGrid1 do begin
          s1:=cells[1,arow];
          s2:=cells[2,arow];
          s3:=cells[3,arow];
        end;
      end;
   2: begin
        with stringGrid2 do begin
          s1:=cells[1,arow];
          s2:=cells[2,arow];
          s3:=cells[3,arow];
        end;
      end;
   3: begin
        with stringGrid3 do begin
          s1:=cells[1,arow];
          s2:=cells[2,arow];
          s3:=cells[3,arow];
        end;
      end;
   4: begin
        with stringGrid4 do begin
          s1:=cells[1,arow];
          s2:=cells[2,arow];
          s3:=cells[3,arow];
        end;
      end;
   end;
   s:=trim(s1);if (s = '-') then s:='0.0';
   val(s,phix,ier);
   if (ier > 0)then begin
     erreur('Read error');
     exit;
   end;
   s:=trim(s2);if (s = '-') then s:='0.0';
   val(s,phiy,ier);
   if (ier > 0)then begin
     erreur('Read error');
     exit;
   end;
   s:=trim(s3);if (s = '-') then s:='0.0';
   val(s,phiz,ier);
   if (ier > 0)then begin
     erreur('Read error');
     exit;
   end;
   if (numero_grille < 3)then cas:=arow else cas:=2*arow;
   setrot(phix,phiy,phiz,ax,ay,az);
   case cas of
    1: mat_mult(ax,az,r);
    2: mat_mult(ay,az,r);
    3: mat_mult(ax,ay,r);
    4: mat_mult(az,ay,r);
    5: mat_mult(az,ay,r);
    6: mat_mult(ax,ay,r);
    7: mat_mult(ay,ax,r);
    8: mat_mult(az,ax,r);
   end;
   trspo(r);
   mat_mult(r,r31,aux);
   ident(aux,r31);
   matinv(r31,r13);
   mat_mult(r21,r13,r23);
   mat_mult(r31,r12,r32);
   message_matrice:='Orientation matrix after reorienting';
   type_diagramme:='laue';
   initialise_activate(sender);
   fdessin.visible:=true;
end;

{$i dfm_reorient}

procedure Tfreorient.init_create(Sender: TObject);
//-----------------------------------------------
begin
  top:=40;
  left:=20;
  edit1.text:='0';
  edit2.text:='0';
  edit3.text:='0';
  radiogroup2.itemIndex:=-1;
  panel1.visible:=false;
  panel2.visible:=false;
  panel4.visible:=false;
  if (screen.width = 800)then reorient800;
end;


procedure Tfreorient.aide(Sender: TObject);
//-----------------------------------------
begin
   Application.HelpFile:='OrientExpress.hlp';
   Application.HelpContext(16);
end;

procedure Tfreorient.efface_grid(Sender: TObject);
//------------------------------------------------
var
  i,j        : integer;
begin
  for i:=0 to 4 do begin
    for j:=0 to 5 do begin
      stringgrid1.cells[i,j]:='';
      stringgrid2.cells[i,j]:='';
      stringgrid3.cells[i,j]:='';
      stringgrid4.cells[i,j]:='';
    end;
  end;
  with stringgrid1 do begin
    cells[0,0]:='Rot.';
    cells[1,0]:='PhiX';Cells[2,0]:='PhiY';Cells[3,0]:='PhiZ';
    cells[0,1]:='1: ZX''';
    cells[0,2]:='2: ZY''';
    cells[0,3]:='3: YX''';
    cells[0,4]:='4: YZ''';
  end;
  with stringgrid2 do begin
    cells[0,0]:='Rot.';
    cells[1,0]:='PhiX';Cells[2,0]:='PhiY';Cells[3,0]:='PhiZ';
    cells[0,1]:='5: ZX''';
    cells[0,2]:='6: ZY''';
    cells[0,3]:='7: YX''';
    cells[0,4]:='8: YZ''';
 end;
  with stringgrid3 do begin
    cells[0,0]:='Rot.';
    cells[1,0]:='PhiX';Cells[2,0]:='PhiY';Cells[3,0]:='PhiZ';
    cells[0,1]:='1: YZ''';
    cells[0,2]:='2: YX''';
    cells[0,3]:='3: XY''';
    cells[0,4]:='4: XZ''';
  end;
  with stringgrid4 do begin
    cells[0,0]:='Rot.';
    cells[1,0]:='PhiX';Cells[2,0]:='PhiY';Cells[3,0]:='PhiZ';
    cells[0,1]:='5: YZ''';
    cells[0,2]:='6: YX''';
    cells[0,3]:='7: XY''';
    cells[0,4]:='8: XZ''';
 end;
end;



end.
