unit coordon2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids;

type
  Tfcoordon2 = class(TForm)
    StringGrid1: TStringGrid;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Memo1: TMemo;
    procedure verification(Sender: TObject);
    procedure effacement_ligne(Sender: TObject);
    procedure go_affinement(Sender: TObject);
    procedure initialise(Sender: TObject);
    procedure onselect(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure peint_cellule1(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fcoordon2: Tfcoordon2;

implementation

uses
oemath,  Affivec2;

var
  no_ligne, nb_ligne : integer;

{$R *.DFM}

procedure Tfcoordon2.verification(Sender: TObject);
//---------------------------------------------
var
  i,{j,}ier      : integer;
  s,s2         : string;
  xx,yy        : single;
begin
//  nobs:=0;
  for i:=1 to 30 do begin
    s:=trim(fcoordon2.StringGrid1.Cells[1,i]);
    add_zero(s);
    if(length(s) = 0)then xx:=0;
    if(length(s) <> 0)then begin
      val(s,xx,ier);
      if(ier <> 0)then begin
        str(i:2,s2);
        s:='Type error (column 1, row'+ s2+')';
        Erreur(s);
        exit;
      end;
    end;
    s:=trim(fcoordon2.StringGrid1.Cells[2,i]);
    add_zero(s);
    if(length(s) = 0)then yy:=0;
    if(length(s) <> 0)then begin
      val(s,yy,ier);
      if(ier <> 0)then begin
        str(i:2,s2);
        s:='Type error at column 2 and row'+ s2;
        Erreur(s);
        exit;
      end;
    end;
  end;


end;

procedure Tfcoordon2.effacement_ligne(Sender: TObject);
//-----------------------------------------------------
var
  i,j,ier            : integer;
  xx,yy              : real;
  s                  : string;
begin
 if (no_ligne > ns )then exit;
 with StringGrid1 do begin
    for i:=0 to 3 do cells[i,no_ligne]:='';
    for i:=no_ligne to ns-1 do begin
         for j:=0 to 3 do Cells[j,i]:=cells[j,i+1];
         cells[0,i]:=intToStr(i);
         x_sup[i]:=x_sup[i+1];
         y_sup[i]:=y_sup[i+1];
         h_sup[i]:=h_sup[i+1];
         k_sup[i]:=k_sup[i+1];
         l_sup[i]:=l_sup[i+1];
    end;
    for j:=0 to 3 do Cells[j,ns]:='';
    ns:=ns-1;
 end;

end;

procedure Tfcoordon2.go_affinement(Sender: TObject);
//--------------------------------------------------
var
  s                         : string;
  xx,yy                     : real;
  hkl,xyz                   : vecteur3;
  h,k,l,i,j,ier             : integer;

begin
  ns:=0;
  for i:=1 to 30 do begin
    s:=trim(stringGrid1.cells[1,i]);
    if (s = '') then s:='0';
    val(s,xx,ier);
    s:=trim(StringGrid1.cells[2,i]);
    val(s,yy,ier);
    if (s = '') then s:='0';
    if(xx = 0) and (yy = 0) then break;
    if (geom = 'FLAT')then begin
      trln(xx,yy,xyz);
    end else begin
      trlnc(xx,yy,xyz);
    end;
    trfo3(xyz,r13);
    indice(xyz,hkl,ier);
    if(ier = 0)then begin
      h:=round(hkl[1]);
      k:=round(hkl[2]);
      l:=round(hkl[3]);
      trfo3(hkl,r21);
      norm(hkl[1],hkl[2],hkl[3]);
      ns:=ns+1;
      x_sup[ns]:=xx;
      y_sup[ns]:=yy;
      h_sup[ns]:=h;
      k_sup[ns]:=k;
      l_sup[ns]:=l;
    end;
  end;
  close;
  faffivec2.visible:=true;
end;

procedure Tfcoordon2.initialise(Sender: TObject);
//-----------------------------------------------
begin
  StringGrid1.cells[0,0]:='  Nb.';
  StringGrid1.cells[1,0]:=' X(Cm)';
  StringGrid1.cells[2,0]:=' Y(Cm)';
  StringGrid1.cells[3,0]:='(h k l)';
end;

procedure Tfcoordon2.onselect(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
//----------------------------------------------------------------
var
  s                         : string;
  xx,yy                     : real;
  hkl,xyz                   : vecteur3;
  h,k,l,i,j,ier             : integer;
begin
  no_ligne:=row;
  if (col = 3)then begin
    s:=trim(stringGrid1.cells[1,row]);
    if (s = '') then exit;
    val(s,xx,ier);
    s:=trim(StringGrid1.cells[2,row]);
    if (s = '')then exit;
    val(s,yy,ier);
    if (s = '') then s:='0';
    if(xx = 0) and (yy = 0) then exit;
    if (geom = 'FLAT')then begin
      trln(xx,yy,xyz);
    end else begin
      trlnc(xx,yy,xyz);
    end;
    trfo3(xyz,r13);
    indice(xyz,hkl,ier);
    if(ier = 0)then begin
      h:=round(hkl[1]);
      k:=round(hkl[2]);
      l:=round(hkl[3]);
      trfo3(hkl,r21);
      norm(hkl[1],hkl[2],hkl[3]);
      ns:=ns+1;
      x_sup[ns]:=xx;
      y_sup[ns]:=yy;
      h_sup[ns]:=h;
      k_sup[ns]:=k;
      l_sup[ns]:=l;
      stringGrid1.cells[0,row]:=inttostr(ns);
      s:=inttostr(h)+' '+inttostr(k)+' '+inttostr(l);
      stringGrid1.cells[3,row]:=s;
    end;
  end;
end;

procedure Tfcoordon2.peint_cellule1(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//-----------------------------------------------------------------------
var
  s   : string;
  posx: integer;
begin
  s:=stringgrid1.cells[col,row];
  posx:= ((Rect.right-rect.left-2)-stringgrid1.canvas.textWidth(s)) div 2;
  stringgrid1.canvas.textrect(rect,rect.left+posx,rect.top,s);
end;

end.
