{
  TCommPortDriver demo
  v1.00 15/FEB/1997 First implementation
  v1.01 19/APR/1997 Some bug fixes (in the demo)
}

unit digital;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls,

  ComDrv32, Menus;

type
  TFdigital = class(TForm)
    CommPortDriver: TCommPortDriver;
    Panel1: TPanel;
    StatusBar: TStatusBar;
    QuitBtn: TButton;
    ComPortRG: TRadioGroup;
    BaudRateRG: TRadioGroup;
    DataBitsRG: TRadioGroup;
    ParityRG: TRadioGroup;
    HandshakingRG: TRadioGroup;
    RxMemo: TMemo;
    MainMenu1: TMainMenu;
    Configuration1: TMenuItem;
    origine1: TMenuItem;
    mesure1: TMenuItem;
    Quit1: TMenuItem;
    Panel2: TPanel;
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    SaveDialog1: TSaveDialog;
    Panel3: TPanel;
    Button1: TButton;
    Help1: TMenuItem;
    procedure QuitBtnClick(Sender: TObject);
    procedure CommPortDriverReceiveData(Sender: TObject; DataPtr: Pointer;
      DataSize: Integer);
    procedure ConnectBtnClick(Sender: TObject);
    procedure DisconnectBtnClick(Sender: TObject);
    procedure BaudRateRGClick(Sender: TObject);
    procedure DataBitsRGClick(Sender: TObject);
    procedure ParityRGClick(Sender: TObject);
    procedure HandshakingRGClick(Sender: TObject);
    procedure ComPortRGClick(Sender: TObject);
    procedure ClrInMemoClick(Sender: TObject);
    procedure ClrOutMemoClick(Sender: TObject);
    procedure SetDTRBtnClick(Sender: TObject);
    procedure ClrDTRBtnClick(Sender: TObject);
    procedure SetRTSBtnClick(Sender: TObject);
    procedure ClrRTSBtnClick(Sender: TObject);
    procedure sortie_de_config(Sender: TObject);
    procedure initialisation(Sender: TObject);
    procedure initialisation_activation(Sender: TObject);
    procedure Configuration(Sender: TObject);
    procedure Sortie(Sender: TObject);
    procedure autorise_origine(Sender: TObject);
    procedure autorise_mesure(Sender: TObject);
    procedure abandon(Sender: TObject);
    procedure Aide_table(Sender: TObject);
  private
    procedure ApplyCommSettings;
  public
  end;

var
  Fdigital: TFdigital;

implementation

{$R *.DFM}
uses
  oemath, affivec2;
var
  //espion                                    : textfile;
  chaine                                    : string;

  flag_mesure,flag_origine                  : boolean;
  x_zero_tab,y_zero_tab                     : real;
  nb_mesures                                : integer;
  xorigine,yorigine                         : array[1..10] of real;

  {nobs                          : integer;
  xobs,yobs                     : array[1..10] of real;}

procedure ecrit_fichier_config;{
-------------------------------}
var
  fichier                                        : TextFile;
  com,baud_rate,data_bits,parity,handshaking  : integer;
begin
  assignFile(fichier,'OrientExpress.cfg');
  rewrite(fichier);
  with fdigital do begin
    com:=ComPortRG.ItemIndex;
    baud_rate:=BaudRateRG.ItemIndex;
    data_bits:=DataBitsRG.ItemIndex;
    parity:=parityRG.ItemIndex;
    handshaking:=HandshakingRG.ItemIndex;
  end;
  writeln(fichier,com:5,baud_rate:5,data_bits:5,parity:5,handshaking:5);
  closefile(fichier);
end;

procedure lecture_fichier_config;{
---------------------------------}
var
  fichier                                     : TextFile;
  com,baud_rate,data_bits,parity,handshaking  : integer;
begin
  if fileExists('OrientExpress.cfg') then begin
    assignFile(fichier,'OrientExpress.cfg');
    reset(fichier);
    readln(fichier,com,baud_rate,data_bits,parity,handshaking);
    closefile(fichier);
    with fdigital do begin
      ComPortRG.ItemIndex:=com;
      BaudRateRG.ItemIndex:=baud_rate;
      DataBitsRG.ItemIndex:=data_bits;
      ParityRG.ItemIndex:=parity;
      HandshakingRG.ItemIndex:=handshaking;
    end;
  end else begin
     with fdigital do begin
       ComPortRG.ItemIndex:=0;
       BaudRateRG.ItemIndex:=5;
       DataBitsRG.ItemIndex:=3;
       ParityRG.ItemIndex:=0;
       HandshakingRG.ItemIndex:=1;
       ecrit_fichier_config;
     end;
  end;

end;

procedure TFdigital.QuitBtnClick(Sender: TObject);{
--------------------------------------------------}
begin
  Close;
end;

procedure erreur(s:string);{
---------------------------}
begin
   MessageDlg(s,mtWarning,[mbOK],0);
end;

procedure decode(var x,y:real; var no_bouton:integer);{
------------------------------------------------------}
var
  s,s1   : string;
  ier    : integer;
begin
  s:=chaine;
  s1:=copy(s,2,7);
  val(s1,x,ier);
  if (ier > 0)then begin
    erreur('Erreur sur dcodage de X');
    exit;
  end;
  x:=x/10000;

  s1:=copy(s,11,7);
  val(s1,y,ier);
  if (ier > 0)then begin
    erreur('Erreur sur dcodage de Y');
    exit;
  end;
  y:=y/10000;

  s1:=copy(s,19,2);
  if (s1[1] = '0')then s1[1]:=' ';
  no_bouton:=StrToInt(s1);
  if (ier > 0)then begin
    erreur('Erreur sur dcodage du numro de bouton');
    exit;
  end;

end;

procedure TFdigital.CommPortDriverReceiveData(Sender: TObject;
  DataPtr: Pointer; DataSize: Integer);{
  -----------------------------------------------------------}
var p                      : pchar;
    x,y                    : real;
    no_bouton,i,h,k,l,ier  : integer;
    s,s1,s2,s3             : string;
    hkl,xyz                : vecteur3;
    nomf                   : TextFile;
begin
  p := DataPtr;
  while DataSize > 0 do
  begin
    case p^ of
      #13: // CR (entre)
{---------------------------------------------------------------------------}
        begin
          decode(x,y,no_bouton);

          // Dtermination de l'origine?
          if (flag_origine = true) and  (flag_mesure = false) then begin
            if (no_bouton = 16) then begin       // fin de mesure
              x_zero_tab:=0;
              y_zero_tab:=0;
              rxmemo.visible:=false;
              for i:=1 to nb_mesures do begin    // Moyenne des mesures autour du zero
                x_zero_tab:=x_zero_tab+xorigine[i];
                y_zero_tab:=y_zero_tab+yorigine[i];
              end;
              x_zero_tab:=x_zero_tab/nb_mesures;
              y_zero_tab:=y_zero_tab/nb_mesures;
              str(x_zero_tab:7:2,s1);             // Affichage des coord. du zero
              edit1.text:=s1;
              str(y_zero_tab:7:2,s1);
              rxmemo.clear;
              edit2.text:=s1;
              flag_origine:=false;
              flag_mesure:=false;
              nb_mesures:=0;
              mesure1.enabled:=true;
            end else if(no_bouton = 15) then begin // Effacement de la mesure
              RxMemo.Lines.clear;
              nb_mesures:=nb_mesures-1;
              for i:=1 to nb_mesures do begin
                str(xorigine[i]:7:2,s1);
                str(yorigine[i]:7:2,s2);
                rxMemo.lines.add(IntToStr(i)+' '+s1+' '+s2);
              end;
            end else begin                        // Mesure bonne
              nb_mesures:=nb_mesures+1;
              xorigine[nb_mesures]:=x;
              yorigine[nb_mesures]:=y;
              str(xorigine[nb_mesures]:7:2,s1);
              str(yorigine[nb_mesures]:7:2,s2);
              rxMemo.lines.add(IntToStr(nb_mesures)+' '+s1+' '+s2);
              beep;
            end;
          end;

          // Mesure des coordonnes pour indexation?
          if (flag_origine = false) and (flag_mesure = true)
          and (flag_supple = false)then begin
            if (no_bouton = 16) then begin        // Fin de mesure
              flag_origine:=false;
              flag_mesure:=false;
              rxmemo.visible:=false;
              nobs:=nb_mesures;
              nb_mesures:=0;
              SaveDialog1.filterIndex:=1;         // Sauvegarde des coordonnes
              if SaveDialog1.execute then s:=SaveDialog1.filename;
              if (pos(s,'.coo') = 0)then s:=s+'.coo';
              nom_fichier_coord:=s;
              AssignFile(nomf,nom_fichier_coord);
              rewrite(nomf);
              for i:=1 to nobs do writeln(nomf,xobs[i]:8:2,yobs[i]:8:2);
              closeFile(nomf);
              close;
           end else if (no_bouton = 15) then begin//  Effacement de la mesure
              RxMemo.Lines.clear;
              nb_mesures:=nb_mesures-1;
              for i:=1 to nb_mesures do begin
                str(xobs[i]:7:2,s1);
                str(yobs[i]:7:2,s2);
                rxMemo.lines.add(IntToStr(i)+' '+s1+' '+s2);
              end;
            end else begin                         //  Mesure bonne
              nb_mesures:=nb_mesures+1;
              xobs[nb_mesures]:=x-x_zero_tab;
              yobs[nb_mesures]:=y-y_zero_tab;
              str(xobs[nb_mesures]:7:2,s1);
              str(yobs[nb_mesures]:7:2,s2);
              rxMemo.lines.add(IntToStr(nb_mesures)+' '+s1+' '+s2);
              beep;
            end;
          end;

          // Mesure des coordonnes supplmentaires?
          if (flag_origine = false) and (flag_mesure = true)
          and (flag_supple = true)then begin
            if (no_bouton = 16) then begin
               close;          // Fin de mesure
               faffivec2.visible:=true;
               exit;
            end else if (no_bouton = 15) then begin  //  Effacement de la mesure
              RxMemo.Lines.clear;
              ns:=ns-1;
              for i:=1 to ns do begin
                str(x_sup[i]:7:2,s1);
                str(y_sup[i]:7:2,s2);
                rxMemo.lines.add(IntToStr(i)+' '+s1+' '+s2);
              end;
            end else begin                          //  Mesure bonne
              x:=x-x_zero_tab;
              y:=y-y_zero_tab;
              if (geom = 'FLAT')then begin
                 trln(x,y,xyz);
              end else begin
                 trlnc(x,y,xyz);
              end;
              trfo3(xyz,r13);
              indice(xyz,hkl,ier);
              if(ier = 0)then begin
                 h:=round(hkl[1]);
                 k:=round(hkl[2]);
                 l:=round(hkl[3]);
                 trfo3(hkl,r21);
                 norm(hkl[1],hkl[2],hkl[3]);
                 ns:=ns+1;
                 x_sup[ns]:=x;
                 y_sup[ns]:=y;
                 h_sup[ns]:=h;
                 k_sup[ns]:=k;
                 l_sup[ns]:=l;
                 if(ns = 30) then begin
                    close;
                    //faffivec2.visible:=true;
                    exit;
                 end;
                 s:='(';
                 str(h:2,s1);
                 s:=s+s1;
                 str(k:2,s1);
                 s:=s+s1;
                 str(l:2,s1);
                 s:=s+s1+') ';
                 //shkl[ns]:=s+s1+')';
                 str(x_sup[ns]:7:2,s1);
                 str(y_sup[ns]:7:2,s2);
                 s:=s+s1+s2;
                 rxMemo.lines.add(IntToStr(ns)+s);
                 beep;
              end;
            end;
          end;

          {writeln(espion,'X=',x:7:2,' Y=',y:7:2,' bouton:',no_bouton:1);}
          chaine := '';
        end;
{-----------------------------------------------------------------------------}
      else // On ajoute les caractres
        chaine := chaine + p^;
    end;
    dec( DataSize );
    inc( p );
  end;
  RxMemo.Update;
end;

procedure TFdigital.ConnectBtnClick(Sender: TObject);{
-----------------------------------------------------}
begin
  // Apply settings
  ApplyCommSettings;
  // Connect
  if CommPortDriver.Connect then
  begin
    {ConnectBtn.Enabled := false;
    DisconnectBtn.Enabled := true;}
    StatusBar.SimpleText := 'Connected';
    {TxMemo.SetFocus;}
  end
  else // Error !
    begin
      StatusBar.SimpleText :=
      'Error: could not connect. Check COM port settings and try again.';
      MessageBeep( 0 );
    end;
end;

procedure TFdigital.DisconnectBtnClick(Sender: TObject);{
--------------------------------------------------------}
begin
  StatusBar.SimpleText := 'Disconnected';
  CommPortDriver.Disconnect;
  {DisconnectBtn.Enabled := false;
  ConnectBtn.Enabled := true;}
end;

procedure TFdigital.BaudRateRGClick(Sender: TObject);{
-----------------------------------------------------}
begin
  CommPortDriver.ComPortSpeed := TComPortBaudRate(BaudRateRG.ItemIndex+1);
end;

procedure TFdigital.DataBitsRGClick(Sender: TObject);{
------------------------------------------------------}
begin
  CommPortDriver.ComPortDataBits := TComPortDataBits(DataBitsRG.ItemIndex);
end;

procedure TFdigital.ParityRGClick(Sender: TObject);{
---------------------------------------------------}
begin
  CommPortDriver.ComPortParity := TComPortParity(ParityRG.ItemIndex);
end;

procedure TFdigital.HandshakingRGClick(Sender: TObject);{
--------------------------------------------------------}
begin
  case HandshakingRG.ItemIndex of
    0: // none
      begin
        CommPortDriver.ComPortHwHandshaking := hhNone;
        CommPortDriver.ComPortSwHandshaking := shNone;
      end;
    1: // RTS/CTS
      begin
        CommPortDriver.ComPortHwHandshaking := hhRTSCTS;
        CommPortDriver.ComPortSwHandshaking := shNone;
      end;
    2: // XON/XOFF
      begin
        CommPortDriver.ComPortHwHandshaking := hhNone;
        CommPortDriver.ComPortSwHandshaking := shXONXOFF;
      end;
    3: // RTS/CTS + XON/XOFF
      begin
        CommPortDriver.ComPortHwHandshaking := hhRTSCTS;
        CommPortDriver.ComPortSwHandshaking := shXONXOFF;
      end;
  end;
end;

procedure TFdigital.ComPortRGClick(Sender: TObject);{
-----------------------------------------------------}
begin
  // Apply com settings
  //ApplyCommSettings;
end;

procedure TFdigital.ApplyCommSettings;{
--------------------------------------}
var wasConnected: boolean;
begin
  wasConnected := CommPortDriver.Connected;
  // This change needs CommPortDriver not connected
  if wasConnected then
    DisconnectBtnClick( nil );

  CommPortDriver.ComPort := TComPortNumber(ord(ComPortRG.ItemIndex));
  BaudRateRGClick( nil );
  DataBitsRGClick( nil );
  ParityRGClick( nil );
  HandshakingRGClick( nil );

  // Reconnect
  if wasConnected then
    ConnectBtnClick( nil );
end;

procedure TFdigital.ClrInMemoClick(Sender: TObject);{
----------------------------------------------------}
begin
  RxMemo.Lines.Clear;
end;

procedure TFdigital.ClrOutMemoClick(Sender: TObject);{
-----------------------------------------------------}
begin
  {TxMemo.Lines.Clear;}
end;

procedure TFdigital.SetDTRBtnClick(Sender: TObject);{
----------------------------------------------------}
begin
  CommPortDriver.ToggleDTR( true );
end;

procedure TFdigital.ClrDTRBtnClick(Sender: TObject);{
-----------------------------------------------------}
begin
  CommPortDriver.ToggleDTR( false );
end;

procedure TFdigital.SetRTSBtnClick(Sender: TObject);{
----------------------------------------------------}
begin
  CommPortDriver.ToggleRTS( true );
end;

procedure TFdigital.ClrRTSBtnClick(Sender: TObject);{
----------------------------------------------------}
begin
  CommPortDriver.ToggleRTS( false );
end;

procedure TFdigital.sortie_de_config(Sender: TObject);{
------------------------------------------------------}
begin
   panel1.visible:=false;
   ecrit_fichier_config;
   ConnectBtnClick(Sender);
   rxmemo.visible:=true;
end;

procedure TFdigital.initialisation(Sender: TObject);{
----------------------------------------------------}
begin
  rxmemo.visible:=false;
  //assignFile(espion,'espion.txt');
  //rewrite(espion);
  ConnectBtnClick(Sender);
  rxmemo.left:=60;
  rxmemo.top:=20;
  panel1.left:=60;
  panel1.top:=20;
  flag_mesure:=false;
  flag_origine:=false;
  x_zero_tab:=0;
  y_zero_tab:=0;
end;

procedure TFdigital.initialisation_activation(Sender: TObject);{
---------------------------------------------------------------}
begin
  rxmemo.clear;
  if (flag_supple = true) then begin
    rxmemo.visible:=true;
    flag_mesure:=true;
    mesure1.enabled:=true;      // Mesure de coordonnes supplmentaires (Affi)
    configuration1.enabled:=false;
    origine1.enabled:=false;
    ns:=0;
    panel3.caption:='Additional measure. "F" Key to end';
  end;
  lecture_fichier_config;
  ConnectBtnClick(Sender);
  if (nobs = 0)then begin        // Mesure des coordonnes pour indexation
    mesure1.enabled:=false;
    configuration1.enabled:=true;
    origine1.enabled:=true;
    flag_supple:=false;
    panel3.caption:='First configure the port and determine the diagram origin';
  end;
end;

procedure TFdigital.Configuration(Sender: TObject);{
---------------------------------------------------}
begin
  rxmemo.visible:=true;
  DisconnectBtnClick(Sender);
  panel1.visible:=true;
  rxmemo.visible:=false;
  panel3.caption:='Configuration';
end;

procedure TFdigital.Sortie(Sender: TObject);{
--------------------------------------------}
begin
  //Closefile(espion);
  close;
end;

procedure TFdigital.autorise_origine(Sender: TObject);{
------------------------------------------------------}
begin
  rxmemo.visible:=true;
  flag_origine:=true;
  flag_mesure:=false;
  RxMemo.Lines.Clear;
  nb_mesures:=0;
  panel3.caption:='Origin determination. "F" Key to end';
end;

procedure TFdigital.autorise_mesure(Sender: TObject);{
-----------------------------------------------------}
begin
  if (x_zero_tab > 0) and (y_zero_tab > 0)then begin
    flag_origine:=false;
    flag_mesure:=true;
    rxmemo.visible:=true;
    RxMemo.Lines.Clear;
    nb_mesures:=0;
    panel3.caption:='Coordinates measurement. "F" key to end';
  end else begin
    erreur('First determine the origin!');
  end;
end;

procedure TFdigital.abandon(Sender: TObject);{
---------------------------------------------}
begin
  nom_fichier_coord:='';
  nobs:=0;
  close;
end;

procedure TFdigital.Aide_table(Sender: TObject);
begin
   Application.HelpFile:='orientExpress.hlp';
   Application.HelpContext(27);
end;

end.
