{Bibliothque pour OrientExpress 32 bits}
Unit OEmath;

Interface

Uses
  SysUtils, WinTypes, WinProcs, Messages,
  Controls, StdCtrls, dialogs,math;

type
  matrice3                         = array[1..3,1..3] of real ;
  vecteur3                         = array[1..3] of real;
  tab_sup                          = array[1..30] of single;
  Tab_solutions                    = array[1..30,1..10,1..3] of integer;
  Tab_coordonnees                  = array[1..10] of single;

const
  pir         = 57.2957;
  bra : array[1..8] of string[1] = ('P','I','F','A','B','C','R','D');

var
  det_mat,dhkl,dhkl_max                   : real;
  ibrav,indmax_stereo                     : integer;
  nom_fichier_coord,nom_fichier_donnees   : string;
  repertoire_donnees,repertoire_origine   : string;
  nom_fichier_image                       : string;
  nom_fichier_aide                        : string;
  message_matrice                         : string;
  message_groupe                          : string;
  type_diagramme                          : string;
  flag_print                              : integer;
  flag_supple                             : boolean;

  {Variables concernant les coordonnes des taches}
  xobs                                    : Tab_coordonnees;
  yobs                                    : Tab_coordonnees;
  nobs                                    : integer;
  xyzo                                    : array[1..30,1..3] of real;
  x3o,y3o,z3o,x_sup,y_sup                 : array[1..30] of real;
  h_sup,k_sup,l_sup                       : array[1..30] of integer;
  ns                                      : integer;
  x_zero,y_zero                           : integer;
  nb_cm_pixel                             : real;
  codelta,sidelta                         : real;

  {Coordonnes en pixels du centre du diagramme et echelle bitmap}
  x_origine,y_origine       : integer;
  nb_pixel_cm               : real;
  flag_image                : boolean;
  type_image,no_appel       : integer;

  {variables ncessaires au calcul des solutions}
  ishkl                                   : Tab_solutions;
  nsol,no_sol                             : integer;
  n1,n2 ,limite                           : integer;
  ih1,ih2,ik1,ik2,il1,il2                 : integer;
  jh1,jh2,jk1,jk2,jl1,jl2                 : integer;
  h1_known,k1_known,l1_known              : integer;
  h2_known,k2_known,l2_known              : integer;
  eps                                     : real;
  residu_coord,residu_hkl                 : array[1..30] of real;

  {Variables communes concernant le cristal et la manip}
  r10,r01,r21,r12,r13,r31,r23,r32,r20,r02 : matrice3;
  r13_old                                 : matrice3;
  cel,celr                                : array[1..6] of real;
  a,b,c,alpha,beta,gamma                  : real;
  uvw                                     : vecteur3;
  ca,cb,cc,ae,be,ce,cae,cbe,cce           : real ;
  distance,angle,largeur,hauteur,
  lambda_min,lambda_max                   : real;
  titre,sample_ref                        : string;
  groupe_espace,systeme,bravais,geom      : string;
  largeur_image,hauteur_image             : integer;

  {Tableau des vecteurs rciproques}
  qhkl                 : array[1..50000] of real;
  h3,k3,l3             : array[1..50000] of smallint;
  nt                   : longint;

  {Conditions d'existence du groupe d'espace}
  icmdsi                                 : array[1..6,1..5] of integer;
  ncmdsi,icmddo                          : array[1..6] of integer;
  ncmd                                   : integer;

  {Mesure des coordonnes au clavier:
  coord_clavier=1 pour mesures normales
  coord_clavier=2 pour mesures supplmentaires}
  type_coordon                           : shortint;

//Positions equivalentes
    it                                     : array[1..3,1..3,1..48] of integer;
    ndeg                                   : integer;

procedure verif    (var s:string);
procedure add_zero (var s:string);
function  fexp     (x,y:real):real;
Function  Arcos    (y:real):Real;
function  Atan2    (x,y :real):real;
function  Det      (Mat:matrice3): Real;
procedure matinv   (Mat : matrice3; var mati :matrice3);
Procedure ident    (mat : matrice3; var mati :matrice3);
procedure trspo    (var mat : matrice3);
procedure trspo2   (var mat1,mat2 : matrice3);
procedure trfo     (u1,u2,u3: real; var v1,v2,v3 : real; var r : matrice3);
procedure trfo2    (var u1,u2,u3 : real; var r : matrice3);
procedure trfo3    (var v : vecteur3; var r : matrice3);
procedure trfo4    (var v,u : vecteur3; var r : matrice3);
procedure mat_mult (ma,mb : matrice3; var mc : matrice3);
Procedure prodvec  (x,y: vecteur3; var z :vecteur3);

procedure setmat;
procedure wr            (var nomf:TextFile; Titre:string; Mat:matrice3);
procedure norm          (var p,q,r : real);
procedure norm3         (var v:vecteur3);
procedure normd         (var x,y,z : real);
procedure normr         (var x,y,z : real);
procedure rot           (p0,q0,r0  : real; icas:integer);
Procedure erreur        (s:string);
procedure lecgroup;
procedure lit_matrice   (var nomf:textfile;var rr:matrice3);

procedure premier       (var ih,ik,il: integer; var iph,ipk,ipl,ipgcd: integer);
procedure premier2      (var ih,ik,il:integer);
procedure indice        (var hkl,ehkl : vecteur3; var ier:integer);
procedure trnl          (var x3,y3,z3,xf,yf: real);
procedure trln          (xf,yf :real; var xyz : vecteur3);
procedure trlnc         (xf,yf :real; var xyz : vecteur3);
procedure extin2        (ih,ik,il: integer; var ier: integer);
procedure extinc        (ih,ik,il: integer; var ib:integer);
procedure verif_matrice;
procedure calc_residu_coord(var num_sol:integer);
procedure set_pos_equiv;
procedure hkltostr      (h,k,l: integer; var s:string);

implementation
{R+}

procedure verif(var s:string);{
------------------------------}
var
  n         :integer;
begin
  if (s = '')then begin
    s:='0';
    exit;
  end;
  n:=pos(' .',s);
  if(n < 0)then s[n]:='0';
  n:=pos('. ',s);
  if(n > 0)then s[n+1]:='0';
  n:=pos('-.',s);
  if(n > 0)then insert('0',s,n+1);
  n:=length(s);
  if(s[n] = '.') then s:=s+'0';
end;

procedure add_zero(var s:string);
begin
   if(s = '')then s:='0';
   if(s[length(s)] = '.') then s:=s+'0';
end;

function  fexp(x,y:real):real;
var
  z  : real;
begin
  z:=y*ln(x);
  fexp:=exp(z);
end;

Function  Arcos    (y:real):Real;
var z : real;
begin
  z:=1.-y*y;
  if(z < 0.0000001) then begin
    arcos:=0.;
    exit;
  end;
  z:=y/sqrt(z);
  Arcos:=-ArcTan(z)+pi/2.;
End;

function  Atan2    (x,y :real):real;    {atan2(x,y)=arctang(x/y)}
var alpha,arg_max    :real;
begin
  arg_max:=1;
  if (abs(x) > abs(y))then arg_max:=abs(x);
  if (abs(y) > abs(x))then arg_max:=abs(y);
  x:=x/arg_max;
  y:=y/arg_max;
  if(abs(x) < 0.000001) then begin
    atan2:=0.;
    exit;
  end;
  if(abs(y) < 0.000001) then begin
    atan2:=pi/2;
    exit;
  end;
  alpha:= arctan(x/y);
  if(y < 0)then begin
    if(x < 0) then alpha:=alpha-pi;
    if(x > 0) then alpha:=alpha+pi;
  end;
  atan2:=alpha;
  //atan2:=arctan2(y,x);
end;

function  Det      (Mat:matrice3): Real;
begin

  det:=mat[1,1]*(mat[2,2]*mat[3,3]-mat[3,2]*mat[2,3])
      -mat[1,2]*(mat[2,1]*mat[3,3]-mat[3,1]*mat[2,3])
      +mat[1,3]*(mat[2,1]*mat[3,2]-mat[3,1]*mat[2,2]);

end;

{Inversion de matrice}
procedure matinv   (Mat : matrice3; var Mati : matrice3);
var
  i,j      : integer;

begin

  mati[1,1]:=mat[2,2]*mat[3,3]-mat[2,3]*mat[3,2];
  mati[1,2]:=mat[1,3]*mat[3,2]-mat[1,2]*mat[3,3];
  mati[1,3]:=mat[1,2]*mat[2,3]-mat[1,3]*mat[2,2];

  mati[2,1]:=mat[2,3]*mat[3,1]-mat[2,1]*mat[3,3];
  mati[2,2]:=mat[1,1]*mat[3,3]-mat[1,3]*mat[3,1];
  mati[2,3]:=mat[1,3]*mat[2,1]-mat[1,1]*mat[2,3];

  mati[3,1]:=mat[2,1]*mat[3,2]-mat[2,2]*mat[3,1];
  mati[3,2]:=mat[1,2]*mat[3,1]-mat[1,1]*mat[3,2];
  mati[3,3]:=mat[1,1]*mat[2,2]-mat[1,2]*mat[2,1];

  det_mat:=det(Mat);

  if(abs(det_mat) < 0.00001)then begin
    erreur('Matrice singulire');
    exit;
  end;

  For i:=1 to 3 do begin
    For j:= 1 to 3 do begin
      mati[i,j]:= mati[i,j]/det_mat;
    end;
  end;

end;

Procedure ident (mat : matrice3; var mati :matrice3);
var i,j  :integer;
begin
  for i:=1 to 3 do begin
    for j:=1 to 3 do begin
      mati[i,j]:=mat[i,j];
    end;
  end;
end;

procedure trspo    (var mat : matrice3);
var
  i,j  :integer;
  mati :matrice3;

begin
  ident(mat,mati);
  for i:=1 to 3 do begin
    for j:=1 to 3 do begin
      mat[i,j]:=mati[j,i];
    end;
  end;
end;

procedure trspo2(var mat1,mat2 : matrice3);

var
  i,j  :integer;
  mati :matrice3;
begin
  for i:=1 to 3 do
    for j:=1 to 3 do mati[i,j]:=mat1[i,j];
  trspo(mati);
  for i:=1 to 3 do
    for j:=1 to 3 do mat2[i,j]:=mati[i,j];
end;

procedure trfo (u1,u2,u3: real; var v1,v2,v3 : real; var r : matrice3);

begin
  v1:=u1*r[1,1]+u2*r[1,2]+u3*r[1,3];
  v2:=u1*r[2,1]+u2*r[2,2]+u3*r[2,3];
  v3:=u1*r[3,1]+u2*r[3,2]+u3*r[3,3];
end;

procedure trfo2(var u1,u2,u3 : real; var r : matrice3);

var
  v1,v2,v3  : real;

begin
  v1:=u1*r[1,1]+u2*r[1,2]+u3*r[1,3];
  v2:=u1*r[2,1]+u2*r[2,2]+u3*r[2,3];
  v3:=u1*r[3,1]+u2*r[3,2]+u3*r[3,3];
  u1:=v1;
  u2:=v2;
  u3:=v3
end;

procedure trfo3(var v : vecteur3; var r : matrice3);

var
  v1,v2,v3  : real;

begin
  v1:=v[1]*r[1,1]+v[2]*r[1,2]+v[3]*r[1,3];
  v2:=v[1]*r[2,1]+v[2]*r[2,2]+v[3]*r[2,3];
  v3:=v[1]*r[3,1]+v[2]*r[3,2]+v[3]*r[3,3];
  v[1]:=v1;
  v[2]:=v2;
  v[3]:=v3;
end;

procedure trfo4(var v,u : vecteur3; var r : matrice3);
var
  v1,v2,v3 : real;

begin
  v1:=v[1]*r[1,1]+v[2]*r[1,2]+v[3]*r[1,3];
  v2:=v[1]*r[2,1]+v[2]*r[2,2]+v[3]*r[2,3];
  v3:=v[1]*r[3,1]+v[2]*r[3,2]+v[3]*r[3,3];
  u[1]:=v1;
  u[2]:=v2;
  u[3]:=v3;
end;

{Produit vectoriel}
Procedure prodvec(x,y: vecteur3; var z :vecteur3);
begin
   z[1]:=x[2]*y[3]-x[3]*y[2];
   z[2]:=x[3]*y[1]-x[1]*y[3];
   z[3]:=x[1]*y[2]-x[2]*y[1];
end;

{Multiplication de matrices}
procedure mat_mult (ma,mb: matrice3; var mc : matrice3);

var
  i,j,k :integer;

begin
  for k:=1 to 3 do begin
    for j:=1 to 3 do begin
      mc[j,k]:=0;
      for i:=1 to 3 do begin
        mc[j,k]:=mc[j,k]+ma[j,i]*mb[i,k];
      end;
    end;
  end;

end;

procedure setmat;
var
      sa,sb,sc,{sae,}sbe,sce               :real;
      q,v                                  :real;
      i,j                                  :integer;
      aux                                  :matrice3;

begin
      {assignFile(nomat,'matrices.txt');
      rewrite(nomat);}
      cel[1]:=a;
      cel[2]:=b;
      cel[3]:=c;
      cel[4]:=alpha;
      cel[5]:=beta;
      cel[6]:=gamma;
      ca:=cos(cel[4]/57.2957);
      cb:=cos(cel[5]/57.2957);
      cc:=cos(cel[6]/57.2957);
{      writeln(nomat,'ca,cb,cc:',ca:12:6,cb:12:6,cc:12:6);}
      sa:=sin(cel[4]/57.2957);
      sb:=sin(cel[5]/57.2957);
      sc:=sin(cel[6]/57.2957);
{      writeln(nomat,'sa,sb,sc:',sa:12:6,sb:12:6,sc:12:6);}
      q:=1.-ca*ca-cb*cb-cc*cc+2.*ca*cb*cc;
      v:=a*b*c*sqrt(q);
      celr[1]:=b*c*sa/v;
      celr[2]:=c*a*sb/v;
      celr[3]:=a*b*sc/v;
      cae:=(cb*cc-ca)/(sb*sc);
      cbe:=(cc*ca-cb)/(sc*sa);
      cce:=(ca*cb-cc)/(sa*sb);
      celr[4]:=arcos(cae);
      {sae:=sin(celr[4]);}
      celr[4]:=celr[4]*57.2957;
      celr[5]:=arcos(cbe);
      sbe:=sin(celr[5]);
      celr[5]:=celr[5]*57.2957;
      celr[6]:=arcos(cce);
      sce:=sin(celr[6]);
      celr[6]:=celr[6]*57.2957;
      {ve:=1./v;}
      ae:=celr[1];
      be:=celr[2];
      ce:=celr[3];
{      for i:=1 to 6 do begin
        write(nomat,celr[i]:10:6);
      end;
      writeln(nomat);}
{-----Calcul de la matrice de passage du r.r. au res. rl et inversemt}
      r01[1,1]:=ae*ae;
      r01[1,2]:=ae*be*cce;
      r01[1,3]:=ae*ce*cbe;
      r01[2,2]:=be*be;
      r01[2,3]:=ce*be*cae;
      r01[3,3]:=ce*ce;

      r10[1,1]:=a*a;
      r10[1,2]:=a*b*cc;
      r10[1,3]:=a*c*cb;
      r10[2,2]:=b*b;
      r10[2,3]:=c*b*ca;
      r10[3,3]:=c*c;

      for i:=1 to 3 do begin
        for j:=1 to 3 do begin
          r01[j,i]:=r01[i,j];
          r10[j,i]:=r10[i,j];
        end;
      end;

{-----Orthonormalisation du rseau rciproque R21}
      for i:=1 to 3 do begin
        for j:=1 to 3 do begin
          r21[i,j]:=0.;
        end;
      end;
      r21[1,1]:=celr[1];
      r21[1,2]:=celr[2]*cce;
      r21[1,3]:=celr[3]*cbe;
      r21[2,2]:=celr[2]*sce;
      r21[2,3]:=-celr[3]*sbe*ca;
      r21[3,3]:=1./cel[3];

{-----Orthonormaisation du rseau direct R20}
      matinv(r21,r12);
      mat_mult(r21,r10,r20);
      mat_mult(r01,r12,r02);

      mat_mult(r01,r10,aux);
  end;

procedure wr       (var nomf:TextFile; Titre:string; Mat:matrice3);
var
  i,j  : integer;
begin

  writeln(nomf,Titre);
  for i:=1 to 3 do begin
    for j:=1 to 3 do begin
     write(nomf,mat[i,j]:12:5);
    end;
    writeln(nomf);
  end;

end;

{Normalisation d'un vecteur dans l'espace orthonorm}
procedure norm(var p,q,r : real);

var
  x : real;
begin
  x:=sqrt(p*p+q*q+r*r);
  p:=p/x;
  q:=q/x;
  r:=r/x;
end;

procedure norm3(var v:vecteur3);
begin
  norm(v[1],v[2],v[3]);
end;


{Normalisation dans l'espace direct}
procedure normd(var x,y,z:real);

var
  den : real;

begin
   den:=sqrt(x*x*a*a+y*y*b*b+z*z*c*c+2*(x*y*a*b*cc+y*z*b*c*ca+z*x*c*a*cb));
   x:=x/den;
   y:=y/den;
   z:=z/den;
end;

{Normalisation dans l'espace rciproque}
procedure normr(var x,y,z:real);

var
  den : real;
begin
  den:=sqrt(x*x*ae*ae+y*y*be*be+z*z*ce*ce+
  2*(x*y*ae*be*cce+y*z*be*ce*cae+z*x*ce*ae*cbe));
  x:=x/den;
  y:=y/den;
  z:=z/den;
end;

{Calcul de la matrice connaissant seulement le icas(me) vecteur}
procedure rot(p0,q0,r0: real; icas:integer);
var
  p,q,r,racine                            : real;
  i,j                                     : integer;

begin
   trfo(p0,q0,r0,p,q,r,r20);
   norm(p,q,r);

   for i:=1 to 3 do begin
     for j:=1 to 3 do begin
       r32[i,j]:=0;
     end;
   end;

{P,Q,R sur X }
    if(icas = 1)then begin
      racine:=sqrt(r*r+q*q);
      if (racine < 0.0001)then begin
        for i:=1 to 3 do begin
          for j:=1 to 3 do begin
            r32[i,j]:=0;
          end;
          r32[i,i]:=1;
        end;
      end;
      if (racine >= 0.0001)then begin
        r32[1,1]:=p;
        r32[1,2]:=q;
        r32[1,3]:=r;
        r32[2,1]:=0;
        r32[2,2]:=-r/racine;
        r32[2,3]:=q/racine;
        r32[3,1]:=racine;
        r32[3,2]:=-p*q/racine;
        r32[3,3]:=-p*r/racine;
      end;
    end;

{p,p,r sur Y}
    if(icas = 2)then begin
      racine:=sqrt(p*p+r*r);
      if(racine < 0.0001)then begin
        for i:=1 to 3 do begin
          for j:=1 to 3 do begin
            r32[i,j]:=0;
          end;
          r32[i,i]:=1;
        end;
      end;
      if(racine >= 0.0001) then begin
        r32[1,1]:=-p*q/racine;
        r32[1,2]:=racine;
        r32[1,3]:=-q*r/racine;
        r32[2,1]:=p;
        r32[2,2]:=q ;
        r32[2,3]:=r;
        r32[3,1]:=r/racine ;
        r32[3,2]:=0;
        r32[3,3]:=-p/racine;
      end;
    end;

{p,p,r sur Z }
    if(icas = 3)then begin
      racine:=sqrt(p*p+q*q);
      if( racine < 0.0001)then begin
        for i:=1 to 3 do begin
          for j:=1 to 3 do begin
            r32[i,j]:=0;
          end;
          r32[i,i]:=1;
        end;
      end;
      if( racine >= 0.0001)then begin
        r32[1,1]:=q/racine;
        r32[1,2]:=-p/racine;
        r32[1,3]:=0;
        r32[2,1]:=p*r/racine;
        r32[2,2]:=q*r/racine;
        r32[2,3]:=-racine;
        r32[3,1]:=p;
        r32[3,2]:=q;
        r32[3,3]:=r;
      end;
    end;

    matinv(r32,r23);
    mat_mult(r32,r21,r31);
    matinv(r31,r13);
end;

procedure erreur(s:string);
//-------------------------
begin
   MessageDlg(s,mtWarning,[mbOK],0);
end;

procedure lecgroup;{
-------------------}

const condsi: array[1..16] of string = ('H=0','H<0','H>K','H>L','K=0',
   'K<0','K>L','K>H','L=0','L<0','L>H','L>K','H=K','K=L','L=H','H=-K');
const conddo: array[1..28] of string = ('HN2','HN4','HN3','AH>AK','AH>AL',
   'H+KN2','-HKLN3', 'KN2','KN4','KN3','AK>AL','AK>AH','K+LN2','H-KLN3',
    'LN2','LN4','LN3','AL>AH','AL>AK','L+HN2','HK-LN3','HKLN2','H+KN4',
    'K+LN4','L+HN4','2H+LN4','2K+HN4','2L+KN4');
const ncondsi = 16;
const nconddo = 28;

var
  nomf,sortie                  : TextFile;
  nom_group,grpfi,s,grplu      : string;
  cmdlue                       : array [1..6] of string[10];
  trouve                       : integer;

  i,j,l,nn,nb_cond,deb,fin,nbre: integer;

begin
  chdir(repertoire_origine);
  AssignFile(nomf,'Orientexpress.grp');
  Reset(nomf);

  Assign(sortie,'Conditions.txt');
  rewrite(sortie);

  l:=length(groupe_espace);
  grplu:=copy(groupe_espace,2,l);
  nom_group:=grplu;
  if ( nom_group = '-3C') and (systeme= 'R') then nom_group:='-3CR';
  if ( nom_group = '3C' ) and (systeme = 'R') then nom_group:='3CR';

  while not(eof(nomf)) do begin
    readln(nomf,grpfi);
    trouve:=0;
    {if ( grpfi[1] = ' ' )then continue;}{provoque le plantage de DELPHI 2}
    if( nom_group = grpfi ) then begin
      trouve:=1;
      break;
    end;
  end;

  if(trouve = 0)then begin
      message_groupe:=
  'Unknown space group or no general extinction (except Bravais lattice)';
      CloseFile(nomf);
      CloseFile(sortie);
      exit
  end;

  writeln(sortie,'nom_groupe rduit:',nom_group);
  writeln(sortie,'nom_groupe trouv:',grpfi);

 {Lecture et criture des conditions jusqu' ligne blanche}
  ncmd:=0;
  while not(eof(nomf)) do begin
    readln(nomf,s);
    l:=length(s);
    if (l = 0) then break;
    ncmd:=ncmd+1;

   {dcodage des conditions : ex: H=0 K=0 (conditions "SI") LN2 (condition "do"}
    deb:=2;
    nb_cond:=0;
    writeln(sortie,'condition lue:',s);
    for i:=2 to l do begin
      if (ord(s[i]) = 32) or (i = l) then begin
        fin:=i-1;
        nb_cond:=nb_cond+1;
        nbre:=i-deb;
        if (i=l) then nbre:=nbre+1;
        cmdlue[nb_cond]:=copy(s,deb,nbre);

        writeln(sortie,'nb_cond',nb_cond:3,' deb,fin:',deb:3,fin:3,
        ' cmdlue:',cmdlue[nb_cond]);

        deb:=i+1;
      end;
    end;
    if(nb_cond < 2)then begin
      ncmd:=ncmd-1;
      break;
    end;

    {nb_cond-1 Conditions "si" par ligne}
    nn:=0;
    for i:=1 to nb_cond-1 do begin
      for j:=1 to ncondsi do begin
        if ( cmdlue[i] = condsi[j] ) then begin

          write(sortie,' If ',cmdlue[i],j:4);

          nn:=nn+1;
          icmdsi[ncmd,nn]:=j;
          ncmdsi[ncmd]:=nn;
          break;
        end;
      end;
    end;

    {Condition DO (1 seule par ligne)}
    for j:=1 to nconddo do begin
      if( cmdlue[nb_cond] = conddo[j] ) then begin

        writeln(sortie,' Do ',cmdlue[nb_cond],j:4);

        icmddo[ncmd]:=j;
        break;
      end;
    end;
  end;
  CloseFile(nomf);
  closefile(sortie);
end;

procedure lit_matrice(var nomf:textfile;var rr:matrice3);
var
  i,j   : integer;
begin
  readln(nomf);
  for i:=1 to 3 do begin
    for j:=1 to 3 do read(nomf,rr[i,j]);
    readln(nomf);
  end;
end;


procedure premier(var ih,ik,il: integer; var iph,ipk,ipl,ipgcd: integer);
{Rduction des indices de Miller  3 nombres premiers}
var
  i,j,mini    :integer;
  ni          :array[1..3] of integer;

 begin
      ipgcd:=1;
      ni[1]:=ih;
      ni[2]:=ik;
      ni[3]:=il;
      iph:=ih;
      ipk:=ik;
      ipl:=il;
      mini:=1000;
      for i:=1 to 3 do begin
        if(ni[i] = 0) then continue;
        j:=abs(ni[i]);
        if(j < mini)then mini:=j;
      end;
      if(mini > 1)then begin
        for j:=mini downto 2 do begin
          if(ni[1] Mod j <> 0)then continue;
          if(ni[2] Mod j <> 0)then continue;
          if(ni[3] Mod j <> 0)then continue;
          iph:=ih div j;
          ipk:=ik div j;
          ipl:=il div j;
          ipgcd:=j;
          exit;
        end;
      end;

end;

procedure premier2(var ih,ik,il:integer);
//---------------------------------------
{Rduction des indices de Miller  3 nombres premiers}
var
  i,j,mini,ipgcd                :integer;
  ni                            :array[1..3] of integer;

 begin
      ipgcd:=1;
      ni[1]:=ih;
      ni[2]:=ik;
      ni[3]:=il;
      mini:=1000;
      for i:=1 to 3 do begin
        if(ni[i] = 0) then continue;
        j:=abs(ni[i]);
        if(j < mini)then mini:=j;
      end;
      if(mini > 1)then begin
        for j:=mini downto 2 do begin
          if(ni[1] Mod j <> 0)then continue;
          if(ni[2] Mod j <> 0)then continue;
          if(ni[3] Mod j <> 0)then continue;
          ih:=ih div j;
          ik:=ik div j;
          il:=il div j;
          ipgcd:=j;
          exit;
        end;
      end;
 end;

procedure indice(var hkl,ehkl : vecteur3; var ier:integer);{
-----------------------------------------------------------}
{Calcul des indices de Miller des taches}

var
  i,j                 : integer;
  xv                  : vecteur3;
  xmax,dif            : real;

begin

  for i:=1 to 3 do ehkl[i]:=0;
  for i:=1 to 3 do xv[i]:=hkl[i];
  xmax:=0.;
  for i:= 1 to 3 do begin
    if( xmax < abs(xv[i]) ) then xmax:=abs(xv[i]);
  end;
  for i:=1 to 3 do xv[i]:=xv[i]/xmax;
  for i:=1 to limite do begin
    dif:=0;
    for j:=1 to 3 do begin
      ehkl[j]:=xv[j]*i;
      dif:=dif+abs(ehkl[j]-round(ehkl[j]));
    end;
    if (dif < 0.1)then begin
      for j:=1 to 3 do ehkl[j]:=round(ehkl[j]);
      ier:=0;
      exit;
    end;
  end;
  ier:=1;
end;

procedure trnl(var x3,y3,z3,xf,yf: real);{
-----------------------------------------}
var
   r2,wl,x3p,y3p,z3p,x4,y4,z4,vv   : real;
begin
     r2:=x3*x3+y3*y3+z3*z3;
     wl:=2*x3/r2;
     x3p:=x3*wl-1;
     y3p:=y3*wl;
     z3p:=z3*wl;
     x4:=x3p*codelta-y3p*sidelta;
     y4:=x3p*sidelta+y3p*codelta;
     z4:=z3p;
     if (geom = 'CYL') then begin
       xf:=distance*atan2(-y4,x4);
       yf:=z4*distance/sqrt(x4*x4+y4*y4);
     end else begin
       vv:=distance/x4;
       xf:=-vv*y4;
       yf:=vv*z4;
     end;
end;

procedure trln(xf,yf :real; var xyz : vecteur3);
{calcul du vecteur rciproque orthonorm  partir des coord. film}

var
v,co,si                 : real;
xyz4                    : vecteur3;
i                       : integer;

begin
  co:=cos(angle/57.2957);
  si:=sin(angle/57.2957);
  v:=sqrt(xf*xf+yf*yf+distance*distance);
  xyz4[1]:=-distance/v;
  xyz4[2]:=xf/v;
  xyz4[3]:=yf/v;
  xyz[1]:=xyz4[1]*co-xyz4[2]*si;
  xyz[2]:=xyz4[1]*si+xyz4[2]*co;
  xyz[3]:=xyz4[3];
  xyz[1]:=xyz[1]+1;
  v:=0;
  for i:=1 to 3 do v:=v+xyz[i]*xyz[i];
  v:=sqrt(v);
  for i:=1 to 3 do xyz[i]:=xyz[i]/v;
end;

procedure trlnc(xf,yf :real; var xyz : vecteur3);
{calcul du vecteur rciproque orthonorm  partir des coord. film}

var
  co,si,phi,x3,y3,z3,x4,y4,z4     : real;

begin
  phi:=xf/distance;
  x4:=-distance*cos(phi);
  y4:=distance*sin(phi);
  z4:=yf;
  norm(x4,y4,z4);
  co:=cos(angle/57.2957);
  si:=sin(angle/57.2957);
  x3:=x4*co-y4*si;
  y3:=x4*si+y4*co;
  z3:=z4;
  x3:=x3+1;
  norm(x3,y3,z3);
  xyz[1]:=x3;
  xyz[2]:=y3;
  xyz[3]:=z3;
end;

procedure extin2(ih,ik,il: integer; var ier: integer);

var
i,j,jer     :integer;

begin
  if(ih = 0) and (ik = 0) and (il = 0)then begin
    ier:=1;
    exit;
  end;
        if (ih=-1) and (ik=1) and (il=1)then  begin
          ier:=0;
        end;

{Commandes 'SI'}
  ier:=0;
  for i:=1 to ncmd do begin
    jer:=0;
    for j:=1 to ncmdsi[i] do begin
        case icmdsi[i,j] of
          1: if (ih <> 0)then jer:=1;
          2: if (ih > 0 )then jer:=1;
          3: if (ih < ik)then jer:=1;
          4: if (ih < il)then jer:=1;
          5: if (ik <> 0)then jer:=1;
          6: if (ik > 0 )then jer:=1;
          7: if (ik < il)then jer:=1;
          8: if (ik < ih)then jer:=1;
          9: if (il <> 0)then jer:=1;
          10:if (il >= 0)then jer:=1;
          11:if (il <= ih)then jer:=1;
          12:if (il <= ik)then jer:=1;
          13:if (ih <> ik)then jer:=1;
          14:if (ik <> il)then jer:=1;
          15:if (il <> ih)then jer:=1;
          16:if (ih <>-ik)then jer:=1;
          17:if (ik <>-il)then jer:=1;
          18:if (il <>-ih)then jer:=1;
        end
      end;

      {jer:=1 les conditions "SI" de la commande ne sont pas satisfaites}
      if(jer = 1)then continue;

      {Condition DO}
      ier:=0;
      case icmddo[i] of
        1:  if( (ih mod 2) <> 0 ) then ier:=1;
        2:  if( (ih mod 4) <> 0 ) then ier:=1;
        3:  if( (ih mod 3) <> 0 ) then ier:=1 ;
        4:  if( abs(ih) > abs(ik) ) then ier:=1;
        5:  if( abs(ih) > abs(il) ) then ier:=1;
        6:  if( ((ih+ik) mod 2) <> 0 ) then ier:=1;
        7:  if( ((-ih+ik+il) mod 3) <> 0 ) then ier:=1;
        8:  if( (ik mod 2) <> 0 ) then ier:=1;
        9:  if( (ik mod 4) <> 0 ) then ier:=1;
        10: if( (ik mod 3) <> 0 ) then ier:=1;
        11: if( abs(ik) > abs(il)) then ier:=1;
        12: if( abs(ik) > abs(ih)) then ier:=1;
        13: if( ((ik+il) mod 2) <> 0 ) then ier:=1;
        14: if( ((ih-ik+il) mod 3) <> 0 ) then ier:=1;
        15: if( (il mod 2) <> 0 ) then ier:=1;
        16: if( (il mod 4) <> 0 ) then ier:=1;
        17: if( (il mod 3) <> 0 ) then ier:=1;
        18: if( abs(il) > abs(ih) ) then ier:=1;
        19: if( abs(il) > abs(ik) ) then ier:=1;
        20: if( ((il+ih) mod 2) <> 0 ) then ier:=1;
        21: if( ((ih+ik-il) mod 3) <> 0 ) then ier:=1;
        22: if( ((ih+ik+il) mod 2) <> 0 ) then ier:=1;
        23: if( ((ih+ik) mod 4) <> 0 ) then ier:=1;
        24: if( ((ik+il) mod 4) <> 0 ) then ier:=1;
        25: if( ((il+ih) mod 4) <> 0 ) then ier:=1;
        26: if( ((2*ih+il) mod 4) <> 0 ) then ier:=1;
        27: if( ((2*ik+ih) mod 4) <> 0 ) then ier:=1;
        28: if( ((2*il+ik) mod 4) <> 0 ) then ier:=1;
      end;
      if (ier = 1) then exit;
      {!la condition Do n'est pas satisfaite}
    end;

end;

{Extinctions du rseau de Bravais + extinctions du groupe.
(ib:=0 : c'est bon)}
procedure extinc(ih,ik,il: integer; var ib:integer);
var
  is1,is2,is3,isom1,isom2       : integer;
  ibon                          : integer;

begin
  ib:=1;
  case ibrav of
    1:                       {Primitif}
      ib:=0;
    2:                       {Corps centr}
      if( ((ih+ik+il) mod 2) = 0) then ib:=0;
    3:                       {Faces centres}
      begin
        is1:=ih+ik;
        is2:=ik+il;
        is3:=il+ih;
        isom1:=abs(is1 mod 2)+abs(is2 mod 2)+abs(is3 mod 2);
        if( isom1 = 0 )then ib:=0;
      end;
    4:
      if ((ik+il) mod 2) = 0 then ib:=0; {Face A centre}
    5:
      if ((il+ih) mod 2) = 0 then ib:=0; {Face B centre}
    6:
      if ((ih+ik) mod 2) = 0 then ib:=0; {Face C centre}
    7:                                   {Rhombodrique index en Hexagonal}
      if ((-ih+ik+il) mod 3) = 0 then ib:=0;
    8:                                   {Diamant}
      begin
        is1:=ih+ik;
        is2:=ik+il;
        is3:=il+ih;
        isom1:=abs(is1 mod 2)+abs(is2 mod 2)+abs(is3 mod 2);
        if( isom1 = 0 )then begin
          isom2:=abs((ih+ik+il) mod 4);
          ib:=0;
          if(isom2 = 2)then ib:=1;
        end;
        if(isom1 <> 0 ) then ib:=1;
      end
     {else ib:=1}
  end;
  if(ib = 0)then begin
    extin2(ih,ik,il,ibon);
    ib:=ibon;
  end;
end;


{Vrification de la matrice d'Orientation. Ecriture dans un fichier verif.txt}
procedure verif_matrice;{
------------------------}
var
  v1,v2,v3,v3p             : vecteur3;
  nomf                     : TextFile;
  i                        : integer;
  x                        : real;
  maille                   : array[1..6] of real;
begin
  assignFile(nomf,'verif.txt');
  rewrite(nomf);

  for i:=1 to 6 do maille[i]:=0;

  for i:=1 to 3 do begin
    v1[i]:=r13[1,i];
    v2[i]:=r13[2,i];
    v3[i]:=r13[3,i];
    maille[1]:=maille[1]+v1[i]*v1[i];
    maille[2]:=maille[2]+v2[i]*v2[i];
    maille[3]:=maille[3]+v3[i]*v3[i];
  end;

  for i:=1 to 3 do maille[i]:=sqrt(maille[i]);

  norm3(v1);
  norm3(v2);
  norm3(v3);

  x:=0;
  for i:=1 to 3 do x:=x+v1[i]*v2[i];
  maille[4]:=57.2957*arccos(x);
  writeln(nomf,x:10:5,maille[4]:8:3);
  x:=0;
  for i:=1 to 3 do x:=x+v2[i]*v3[i];
  maille[5]:=57.2957*arccos(x);
  writeln(nomf,x:10:5,maille[5]:8:3);
  x:=0;
  for i:=1 to 3 do x:=x+v3[i]*v1[i];
  maille[6]:=57.2957*arccos(x);
  writeln(nomf,x:10:5,maille[6]:8:3);

  writeln(nomf);
  for i:=1 to 6 do write(nomf,maille[i]:8:3);
  writeln(nomf);

  prodvec(v1,v2,v3p);
  norm3(v3p);
  writeln(nomf);
  for i:=1 to 3 do writeln(nomf,v3p[i]:12:6,v3[i]:12:6);

  Closefile(nomf);
end;

procedure calc_residu_coord(var num_sol:integer);{
-------------------------------------------------}
var
   res,xx,yy,zz,xx3c,yy3c,zz3c,xf,yf   : real;
   i,j                                 : integer;
begin
   res:=0;
   for i:=1 to nobs+ns do begin
     if( i <= nobs)then begin
       xx:=ishkl[num_sol,i,1];
       yy:=ishkl[num_sol,i,2];
       zz:=ishkl[num_sol,i,3];
       trfo(xx,yy,zz,xx3c,yy3c,zz3c,r31);
       trnl(xx3c,yy3c,zz3c,xf,yf);
       res:=res+sqr(xf-xobs[i])+sqr(yf-yobs[i]);
     end else begin
       j:=i-nobs;
       xx:=h_sup[j];
       yy:=k_sup[j];
       zz:=l_sup[j];
       trfo(xx,yy,zz,xx3c,yy3c,zz3c,r31);
       trnl(xx3c,yy3c,zz3c,xf,yf);
       res:=res+sqr(xf-x_sup[j])+sqr(yf-y_sup[j]);
    end;
  end;
  residu_coord[num_sol]:=sqrt(res)/(nobs+ns);
end;

procedure set_pos_equiv;
//---------------------
 var
    i,j,k,jj,kk       : integer;
    car               : char;
    nomf              : textfile;
    (*it                                     : array[1..3,1..3,1..48] of integer;
    ndeg                                   : integer; *)
 const
    itc                  : array[1..216] of integer =
     (1, 0, 0,  0, 1, 0,  0, 0, 1,  0, 1, 0,  0, 0, 1,  1, 0, 0,
      0, 0, 1,  1, 0, 0,  0, 1, 0,  1, 0, 0,  0, 0, 1,  0, 1, 0,
      0, 1, 0,  1, 0, 0,  0, 0, 1,  0, 0, 1,  0, 1, 0,  1, 0, 0,
      1, 0, 0,  0,-1, 0,  0, 0,-1,  0,-1, 0,  0, 0,-1,  1, 0, 0,
      0, 0,-1,  1, 0, 0,  0,-1, 0,  1, 0, 0,  0, 0,-1,  0,-1, 0,
      0,-1, 0,  1, 0, 0,  0, 0,-1,  0, 0,-1,  0,-1, 0,  1, 0, 0,
     -1, 0, 0,  0, 1, 0,  0, 0,-1,  0, 1, 0,  0 ,0,-1, -1, 0, 0,
      0, 0,-1, -1, 0, 0,  0, 1, 0, -1, 0, 0,  0, 0,-1,  0, 1, 0,
      0, 1, 0, -1, 0, 0,  0, 0,-1,  0, 0,-1,  0, 1, 0, -1, 0, 0,
     -1, 0, 0,  0,-1, 0,  0, 0, 1,  0,-1, 0,  0, 0, 1, -1, 0, 0,
      0, 0, 1, -1, 0, 0,  0,-1, 0, -1, 0, 0,  0, 0, 1,  0,-1, 0,
      0,-1, 0, -1, 0, 0,  0, 0, 1,  0, 0, 1,  0,-1, 0, -1, 0, 0);

    itq                  : array[1..72] of integer =
      (1,0,0,0,1,0,0,0,1,-1,0,0,0,-1,0,0,0,1,-1,0,0,0,1,0,
      0,0,1,1,0,0,0,-1,0,0,0,1,0,1,0,-1,0,0,0,0,1,0,-1,0,
      1,0,0,0,0,1,0,1,0,1,0,0,0,0,1,0,-1,0,-1,0,0,0,0,1);

    ith                  : array[1..108] of integer =
     ( 1, 0, 0,  0, 1, 0,  0, 0, 1,
       0,-1, 0,  1,-1, 0,  0, 0, 1,
      -1, 1, 0, -1, 0, 0,  0, 0, 1,
       0,-1, 0, -1, 0, 0,  0, 0, 1,
       1, 0, 0,  1,-1, 0,  0, 0, 1,
      -1, 1, 0,  0, 1, 0,  0, 0, 1,
       1, 0, 0,  0, 1, 0,  0, 0, -1,
       0,-1, 0,  1,-1, 0,  0, 0, -1,
      -1, 1, 0, -1, 0, 0,  0, 0, -1,
       0,-1, 0, -1, 0, 0,  0, 0, -1,
       1, 0, 0,  1,-1, 0,  0, 0, -1,
      -1, 1, 0,  0, 1, 0,  0, 0, -1);

    ithr                 : array[1..54] of integer =
     (       1, 0, 0, 0, 1, 0, 0, 0, 1,
             0,-1, 0, 1,-1, 0, 0, 0, 1,
            -1, 1, 0,-1, 0, 0, 0, 0, 1,
             1, 0, 0, 0, 1, 0, 0, 0,-1,
             0,-1, 0, 1,-1, 0, 0, 0,-1,
            -1, 1, 0,-1, 0, 0, 0, 0,-1);

    itr                  : array[1..54] of integer =
     (1,0,0,0,1,0,0,0,1,0,1,0,0,0,1,1,0,0,0,0,1,1,0,0,
      0,1,0,0,1,0,1,0,0,0,0,1,0,0,1,0,1,0,1,0,0,1,0,0,
      0,0,1,0,1,0);

    ito                  : array[1..36] of integer =
      (1,0,0,0,1,0,0,0,1,1,0,0,0,-1,0,0,0,-1,-1,0,0,0,1,0,
       0,0,-1,-1,0,0,0,-1,0,0,0,1);

    itm                  : array[1..18] of integer =
      (1,0,0,0,1,0,0,0,1,-1,0,0,0,1,0,0,0,-1);
    itt                  : array[1..9] of integer =
      (1,0,0,0,1,0,0,0,1);

 begin

//Gnration des indices  partir des valeurs de h_know,k_know,l_known
    car:=systeme[1];
    for i:=1 to 3 do begin
      for j:=1 to 3 do begin
        for k:=1 to 48 do begin
          it[i,j,k]:=0;
        end;
      end;
    end;
    case car of
      'C': begin
           ndeg:=24;
             jj:=0;
             for k:=1 to ndeg do begin
               for i:=1 to 3 do begin
                 for j:=1 to 3 do begin
                    jj:=jj+1;
                    it[i,j,k]:=itc[jj];
                 end;
               end;
             end;
           end;
      'Q': begin
             ndeg:=8;
             jj:=0;
             for k:=1 to ndeg do begin
               for j:=1 to 3 do begin
                 for i:=1 to 3 do begin
                    jj:=jj+1;
                    it[i,j,k]:=itq[jj];
                 end;
               end;
             end;
           end;
      'H': begin
             if (bravais = 'R')then begin
               ndeg:=3;  // on n'en prend que la moiti!
               jj:=0;
               for k:=1 to ndeg do begin
                 for j:=1 to 3 do begin
                   for i:=1 to 3 do begin
                     jj:=jj+1;
                     it[i,j,k]:=ithr[jj];
                   end;
                 end;
               end;
             end else begin
               ndeg:=12;
               jj:=0;
               for k:=1 to ndeg do begin
                 for j:=1 to 3 do begin
                   for i:=1 to 3 do begin
                     jj:=jj+1;
                     it[i,j,k]:=ith[jj];
                   end;
                 end;
               end;
             end;
           end;
      'R': begin
             ndeg:=6;
             jj:=0;
             for k:=1 to ndeg do begin
               for j:=1 to 3 do begin
                 for i:=1 to 3 do begin
                    jj:=jj+1;
                    it[i,j,k]:=itr[jj];
                 end;
              end;
             end;
           end;
      'O': begin
             ndeg:=4;
             jj:=0;
             for k:=1 to ndeg do begin
               for j:=1 to 3 do begin
                 for i:=1 to 3 do begin
                    jj:=jj+1;
                    it[i,j,k]:=ito[jj];
                 end;
              end;
             end;
           end;
      'M': begin
             ndeg:=2;
             jj:=0;
             for k:=1 to ndeg do begin
               for j:=1 to 3 do begin
                 for i:=1 to 3 do begin
                    jj:=jj+1;
                    it[i,j,k]:=itm[jj];
                 end;
              end;
             end;
           end;
      'T': begin
             ndeg:=1;
             jj:=0;
             for k:=1 to ndeg do begin
               for j:=1 to 3 do begin
                 for i:=1 to 3 do begin
                    jj:=jj+1;
                    it[i,j,k]:=itt[jj];
                  end;
              end;
             end;
           end;
     end;

     for k:=1 to ndeg do begin
       kk:=k+ndeg;
       for i:=1 to 3 do begin
         for j:=1 to 3 do begin
            it[i,j,kk]:=-it[i,j,k];
         end;
       end;
     end;

   (*  assignfile(nomf,'espion.txt');
     rewrite(nomf);
     for k:=1 to 2*ndeg do begin
       for i:=1 to 3 do begin
         for j:=1 to 3 do begin
            write(nomf,it[i,j,k]:5);
         end;
         write(nomf,', ');
       end;
       writeln(nomf);
     end;
     closefile(nomf); *)

end;

procedure hkltostr(h,k,l: integer; var s:string);{
-------------------------------------------------}
var
  s1,s2,s3  : string;
begin
  s:='';
  str(h,s1);
  str(k,s2);
  str(l,s3);
  s:=s1+s2+s3;
end;

end.
