unit supmesure;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, clipbrd;

type
  Tfsupmesure = class(TForm)
    image1: TImage;
    ListBox1: TListBox;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Image2: TImage;
    procedure abandon(Sender: TObject);
    procedure init(Sender: TObject);
    procedure pique_coord(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure go_affinement(Sender: TObject);
    procedure affiche_indices(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure init_creation(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fsupmesure: Tfsupmesure;

implementation

{$R *.DFM}

uses
  oemath, affivec2;
var
   shkl              : array[1..20] of string;

procedure Tfsupmesure.abandon(Sender: TObject);{
------------------------------------------}
begin
  ns:=0;
  close;
end;

procedure affiche_coord ;{
-------------------------}
var
  i,j,k,x,y           : integer;
  s,s1                : string;
begin
  with fsupmesure do begin
    listbox1.clear;
    image1.picture.assign(clipboard);
    for i:=1 to nobs do begin
       x:=x_origine+round(xobs[i]*nb_pixel_cm);
       y:=y_origine-round(yobs[i]*nb_pixel_cm);
       str(i:2,s);
       image1.canvas.textout(x,y,s);
    end;
    if (ns = 0)then exit;
    for i:=1 to ns do begin
       str(i:2,s);
       s:=s+' '+shkl[i];
       x:=x_origine+round(x_sup[i]*nb_pixel_cm);
       y:=y_origine-round(y_sup[i]*nb_pixel_cm);
       image1.canvas.textout(x+2,y+2,s);
       image1.canvas.pen.color:=clred;
       image1.canvas.moveto(x-6,y);
       image1.canvas.lineto(x+6,y);
       image1.canvas.moveto(x,y+6);
       image1.canvas.lineto(x,y-6);
       image1.canvas.pen.color:=clblack;
       str(x_sup[i]:7:2,s1);
       s:=s+s1;
       str(y_sup[i]:7:2,s1);
       s:=s+' '+s1;
       ListBox1.Items.add(s);
    end;
  end;
end;

procedure Tfsupmesure.init(Sender: TObject);{
---------------------------------------}
begin
    left:=20;
    top:=40;
    ns:=0;
    affiche_coord;
end;

procedure Tfsupmesure.pique_coord(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);{
------------------------------------------------------------------}
var
  s,s1                                 : string;
  xf,yf                                : real;
  hkl,xyz                              : vecteur3;
  h,k,l,i,j,ier                        : integer;
begin
 xf:=(-x_origine+x)/nb_pixel_cm;
 yf:=(y_origine-y)/nb_pixel_cm;

 if (button = mbright) then begin {Effacement}
   if (ns = 0)then exit;
   if (ns > 0)then begin;
     for i:=1 to ns do begin
       if(ns > 1)and(abs(x_sup[i]-xf) < 0.1)and(abs(y_sup[i]-yf) < 0.1)then begin
         for j:=i to ns-1 do begin
           x_sup[j]:=x_sup[j+1];
           y_sup[j]:=y_sup[j+1];
         end;
       end;
     end;
     ns:=ns-1;
     affiche_coord;
   end;

 end else begin                  {Mesure}
   if (geom = 'FLAT')then begin
     trln(xf,yf,xyz);
   end else begin
     trlnc(xf,yf,xyz);
   end;
   trfo3(xyz,r13);
   indice(xyz,hkl,ier);
   if(ier = 0)then begin
     h:=round(hkl[1]);
     k:=round(hkl[2]);
     l:=round(hkl[3]);
     trfo3(hkl,r21);
     norm(hkl[1],hkl[2],hkl[3]);
     ns:=ns+1;
     x_sup[ns]:=xf;
     y_sup[ns]:=yf;
     h_sup[ns]:=h;
     k_sup[ns]:=k;
     l_sup[ns]:=l;
     if(ns = 30) then begin
       fsupmesure.close;
       faffivec2.visible:=true;
       exit;
     end;
     s:='(';
     str(h:2,s1);
     s:=s+s1;
     str(k:2,s1);
     s:=s+s1;
     str(l:2,s1);
     shkl[ns]:=s+s1+')';
     affiche_coord;
   end else begin
     image1.canvas.textout(x,y,'?');
   end;
 end;

end;

procedure Tfsupmesure.go_affinement(Sender: TObject);{
-----------------------------------------------------}
begin
 faffivec2.visible:=true;
 close;
end;

Procedure existe_raie(var h,k,l,ier: integer);{
----------------------------------------------}
var
    i,ih,ik,il,iext,n                                      : integer;
    r2hkl,wl,lambda,ah,ak,al                               : real;
    x3,y3,z3,x3p,y3p,z3p,xx4,yy4,zz4,xf,yf,vv              : real;
begin
  ah:=h;
  ak:=k;
  al:=l;
  ier:=0;
  x3:=r31[1,1]*ah+r31[1,2]*ak+r31[1,3]*al;
  if (x3 < 0.00001) then begin
    ier:=1;
    exit;
  end;
  y3:=r31[2,1]*ah+r31[2,2]*ak+r31[2,3]*al;
  z3:=r31[3,1]*ah+r31[3,2]*ak+r31[3,3]*al;
  r2hkl:=x3*x3+y3*y3+z3*z3;

{La famille de plans peut-elle rflechir dans l'intervalle lambda_min-lambda_max?}
  wl:=2*x3/r2hkl;
  if(wl < lambda_min)then begin
    ier:=1;
    exit;
  end;
  n:=1+round(wl/lambda_min);
  iext:=0;
  for i:=1 to n do begin
    lambda:=wl/i;
    if(lambda > lambda_max)then continue;
    if(lambda < lambda_min)then begin
      ier:=1;
      exit;
    end;
    ih:=round(ah*i);
    ik:=round(ak*i);
    il:=round(al*i);
    extinc(ih,ik,il,iext);
    if(iext = 0) then begin
      ier:=0;
      exit;
    end else begin
      continue;
    end;
  end;
end;

procedure Tfsupmesure.affiche_indices(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
{-------------------------------------------------------------------------}
var
  xf,yf                                : real;
  h,k,l,ier,ier2,hh,hk,hl              : integer;
  hkl,xyz                              : vecteur3;
  s,s1                                 : string;
begin
 xf:=(-x_origine+x)/nb_pixel_cm;
 yf:=(y_origine-y)/nb_pixel_cm;
 if (geom = 'FLAT')then begin
   trln(xf,yf,xyz);
 end else begin
   trlnc(xf,yf,xyz);
 end;
 trfo3(xyz,r13);
 indice(xyz,hkl,ier);
 with image2.canvas do begin
    copyrect(rect(0,0,80,80),image1.canvas,rect(x-20,y-20,x+20,y+20));
    pen.color:=clred;
    moveto(20,40);
    lineto(60,40);
    moveto(40,20);
    lineto(40,60);
 end;
 if (ier = 0)then begin
   h:=round(hkl[1]);
   k:=round(hkl[2]);
   l:=round(hkl[3]);
   existe_raie(h,k,l,ier2);
   if(ier2 = 0) then begin
     hkltostr(h,k,l,s);
     if (systeme='RHOM')then begin
          hh:=h-k;
          hk:=k-l;
          hl:=h+k+l;
          premier2(hh,hk,hl);
          hkltostr(hh,hk,hl,s1);
          s:=s+'(H'+s1+')';
     end;
     edit1.visible:=true;
     edit1.text:=s;
   end else begin
     edit1.visible:=false;
     edit1.text:='';
   end;
 end else begin
   edit1.text:='';
 end;

end;

{$i dfm_supmesure.pas}
procedure Tfsupmesure.init_creation(Sender: TObject);
//---------------------------------------------------
begin
  if (screen.width = 800) then supmesure800;
end;


end.
